#include "pch.h"

// Ŭκ  ü . ŸԸ ü Ѵ.
CWidget* CWidget::CreateObject(wstring cls)
{
	if (cls == L"Clock") return new CClock();
	if (cls == L"Radix") return new CRadix();
	if (cls == L"CpuUsage") return new CCpuUsage();
	if (cls == L"MemUsage") return new CMemUsage();
	if (cls == L"Battery") return new CBattery();
	if (cls == L"DiskUsage") return new CDiskUsage();
	if (cls == L"Calc") return new CCalc();
	if (cls == L"MusicPlayer") return new CMusicPlayer();
	if (cls == L"ImageSlide") return new CImageSlide();
	if (cls == L"Memo") return new CMemo();
	if (cls == L"Dday") return new CDday();

	return nullptr;
}

// Ʈ Ʈ ϰ ʱ Ӽ Ѵ.
CWidget* CWidget::CreateDefaultObject(wstring cls)
{
	CWidget* pWidget = CreateObject(cls);

	int wi;
	for (wi = 0;; wi++) {
		if (arWidgetInfo[wi].cls == L"") return nullptr;
		if (arWidgetInfo[wi].cls == cls) break;
	}

	pWidget->dget_cls = cls;
	// Ƽ   Ŭ ״ Ѵ.
	if (arWidgetInfo[wi].allowMulti == false) {
		pWidget->dget_id = cls;
	} else {
		bool bFind;
		wstring id;
		// Ϸ ȣ    ȣ ã´. 
		for (int num = 1;; num++) {
			// ù ̸ Ŭ ״ Ѵ. 
			if (num == 1) {
				id = cls;
			} else {
				TCHAR tnum[10];
				wsprintf(tnum, L"%d", num);
				id = cls + L"_" + tnum;
			}
			// ̹  ߿ id ϴ  ִ Ѵ.
			bFind = false;
			for (size_t wi = 0; wi < arWidget.size(); wi++) {
				if (arWidget[wi]->dget_id == id) {
					bFind = true;
					break;
				}
			}
			if (bFind == false) break;
		}

		pWidget->dget_id = id;
	}

	pWidget->dget_visible = true;
	pWidget->vertHeight = arWidgetInfo[wi].initHeight;
	pWidget->horzWidth = arWidgetInfo[wi].initWidth;
	pWidget->SetBackColor(arWidgetInfo[wi].initColor);
	pWidget->span = false;
	pWidget->spanRatio = 100;

	return pWidget;
}

void CWidget::Serialize(TCHAR* pack)
{
	wsprintf(pack, L"%s%s%d%d%d%d%d%d%d",
		dget_cls.c_str(), dget_id.c_str(), win_backColor, dget_visible,
		vertHeight, horzWidth, span, spanRatio);
}

CWidget* CWidget::Deserialize(LPCTSTR pack)
{
	TCHAR token[MAX_PATH];
	GetPackToken(pack, 0, token);
	CWidget* pWidget = CreateObject(token);
	pWidget->dget_cls = token;
	GetPackToken(pack, 1, token); pWidget->dget_id = token;
	GetPackToken(pack, 2, token);
	pWidget->SetBackColor(_ttoi(token));
	GetPackToken(pack, 3, token); pWidget->dget_visible = _ttoi(token);
	GetPackToken(pack, 4, token); pWidget->vertHeight = _ttoi(token);
	GetPackToken(pack, 5, token); pWidget->horzWidth = _ttoi(token);
	GetPackToken(pack, 6, token); pWidget->span = _ttoi(token);
	GetPackToken(pack, 7, token); pWidget->spanRatio = _ttoi(token);

	return pWidget;
}

// ׸ũ е ڿ idx° ū д´. 
bool CWidget::GetPackToken(LPCTSTR pack, int idx, TCHAR token[MAX_PATH])
{
	LPCTSTR p = pack;
	LPCTSTR pEnd;
	// idx ° ׸ũ ã´.
	for (int i = 0;; i++) {
		if (i == idx) break;
		pEnd = _tcsstr(p, L"");
		if (pEnd == nullptr) return false;
		p = pEnd + 1;
	}

	// p   Ǵ ڿ  д´.
	memset(token, 0, sizeof(TCHAR) * MAX_PATH);
	pEnd = _tcsstr(p, L"");
	if (pEnd != nullptr) {
		_tcsncpy_s(token, MAX_PATH, p, pEnd - p);
	} else {
		lstrcpy(token, p);
	}

	return true;
}

LRESULT CClock::OnCreate(WPARAM wParam, LPARAM lParam)
{
	LoadSetting();
	SetTimer(win_hWnd, 1, 1000, NULL);
	SendMessage(win_hWnd, WM_TIMER, 1, 0);
	return 0;
}

LRESULT CClock::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	KillTimer(win_hWnd, 1);
	return 0;
}

LRESULT CClock::OnTimer(WPARAM wParam, LPARAM lParam) {
	SYSTEMTIME st;
	GetLocalTime(&st);
	static TCHAR arYoil[][4] = { TEXT(""), TEXT(""), TEXT("ȭ"), TEXT(""),
		TEXT(""), TEXT(""), TEXT("") };
	static TCHAR arYoilEng[][16] = { TEXT("Sun"), TEXT("Mon"), TEXT("Tue"),
		TEXT("Wen"), TEXT("Thr"), TEXT("Fri"), TEXT("Sat") };

	month = st.wMonth;
	day = st.wDay;
	if (lang == eLang::KOR) {
		yoil = arYoil[st.wDayOfWeek];
	} else {
		yoil = arYoilEng[st.wDayOfWeek];
	}

	bool needRepaint;
	if (outSec) {
		needRepaint = (hour != st.wHour || min != st.wMinute || sec != st.wSecond);
	} else {
		needRepaint = (hour != st.wHour || min != st.wMinute);
	}

	hour = st.wHour;
	min = st.wMinute;
	sec = st.wSecond;

	// ǥ ð  ٲ  ٽ ׸.
	if (needRepaint) {
		InvalidateRect(win_hWnd, NULL, TRUE);
	}
	return 0;
}

void CClock::OnDraw(HDC hdc, int width, int height) {
	TCHAR sTime[128];
	HFONT oldFont;

	if (faceType == 0) {
		LPCTSTR ampm;
		int center = height / 2 - 3;

		SetBkMode(hdc, TRANSPARENT);
		SetTextAlign(hdc, TA_CENTER);
		_stprintf_s(sTime, 128, TEXT("%d%d %s"), month, day, yoil.c_str());

		oldFont = (HFONT)SelectObject(hdc, mainFont[3]);
		TextOutSz(hdc, width / 2, center - 20, sTime);

		// ʸ ǥ  Ʈ   Ű.
		SelectObject(hdc, mainFont[outSec ? 4:5]);

		int tHour = hour;
		if (hour24 == false) {
			//  0,  12÷ ǥѴ.
			if (tHour > 12) {
				tHour -= 12;
			}
		}

		TCHAR sDigit[128];
		if (digit2) {
			lstrcpy(sDigit, L"%02d");
		} else {
			lstrcpy(sDigit, L"%d");
		}

		TCHAR sFormat[128];
		lstrcpy(sFormat, sDigit);
		lstrcat(sFormat, L":");
		lstrcat(sFormat, sDigit);
		if (outSec) {
			lstrcat(sFormat, L":");
			lstrcat(sFormat, sDigit);
			wsprintf(sTime, sFormat, tHour, min, sec);
		} else {
			wsprintf(sTime, sFormat, tHour, min);
		}
		TextOutSz(hdc, width / 2, center, sTime);

		// ð տ ⺻ Ʈ /ĸ δ.
		if (hour24 == false) {
			SIZE sz;
			GetTextExtentPoint32(hdc, sTime, lstrlen(sTime), &sz);
			SetTextAlign(hdc, TA_RIGHT | TA_BASELINE);
			SelectObject(hdc, mainFont[1]);
			SetTextColor(hdc, RGB(128, 128, 128));
			if (lang == eLang::KOR) {
				ampm = tHour >= 12 ? L"" : L"";
			} else {
				ampm = tHour >= 12 ? L"PM" : L"AM";
			}
			TextOutSz(hdc, width / 2 - sz.cx / 2 - 3, center + sz.cy - 8, ampm);
		}

		SelectObject(hdc, oldFont);
	}

	if (faceType == 1) {
		int cx = width / 2;
		int cy = height / 2;
		// ª  90% ׸.
		int radius = int(min(cx, cy) * 0.9);
		int timeR;
		HPEN pen, oldPen;
		int rx, ry;

		//  ð  ׸. 
		for (int h = 0; h <= 11; h++) {
			getRadialPos(cx, cy, radius, h, rx, ry);
			if (h % 3 == 0) {
				timeR = 3;
			} else {
				timeR = 2;
			}
			Ellipse(hdc, rx - timeR, ry - timeR, rx + timeR, ry + timeR);
		}

		// ¥  ǥѴ. ð ٴú  Ʒ ׸.
		SetBkMode(hdc, TRANSPARENT);
		oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
		SetTextAlign(hdc, TA_CENTER);
		wsprintf(sTime, TEXT("%d"), month);
		TextOutVCenter(hdc, cx - radius / 2, cy - 7, sTime);
		wsprintf(sTime, TEXT("%d"), day);
		TextOutVCenter(hdc, cx - radius / 2, cy + 7, sTime);
		TextOutVCenter(hdc, cx + radius / 2, cy, yoil.c_str());
		SelectObject(hdc, oldFont);

		int tx, ty;

		// ħ ǥ. ð Ӹ ƴ϶ а Ѵ. 30 0.5ð شѴ.
		pen = CreatePen(PS_SOLID, 3, RGB(255, 0, 0));
		oldPen = (HPEN)SelectObject(hdc, pen);
		getRadialPos(cx, cy, int(radius * 0.6), hour + min / 60.0, tx, ty);
		MoveToEx(hdc, cx, cy, NULL); LineTo(hdc, tx, ty);
		DeleteObject(SelectObject(hdc, oldPen));

		// ħ ǥ. ʸ  Ѵ. 60  12   ٲٷ 5 .
		pen = CreatePen(PS_SOLID, 2, RGB(0, 0, 255));
		oldPen = (HPEN)SelectObject(hdc, pen);
		getRadialPos(cx, cy, int(radius * 0.8), (min + sec / 60.0) / 5, tx, ty);
		MoveToEx(hdc, cx, cy, NULL); LineTo(hdc, tx, ty);
		DeleteObject(SelectObject(hdc, oldPen));

		// ħ ǥ
		if (outSec) {
			pen = CreatePen(PS_SOLID, 1, RGB(128, 128, 128));
			oldPen = (HPEN)SelectObject(hdc, pen);
			getRadialPos(cx, cy, int(radius * 0.8), sec / 5.0, tx, ty);
			MoveToEx(hdc, cx, cy, NULL); LineTo(hdc, tx, ty);
			DeleteObject(SelectObject(hdc, oldPen));
		}
	}
}

LRESULT CClock::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_CLOCK),
			win_hWnd, ClockDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}
	return 0;
}

// ð  ֻ ǥ Ѵ.
void CClock::getRadialPos(int cx, int cy, int radius, double hour, int& x, int& y)
{
	// ð  ٲ۴.    360   ٲ۴.
	double angle = -30 * hour + 90;
	if (angle < 0) angle += 360;
	//   ٲ۴.
	double radian = angle * 3.1415 / 180;

	// Ͱ 1/4и̹Ƿ y ǥ .
	x = int(cx + radius * cos(radian));
	y = int(cy - radius * sin(radian));
}

void CClock::LoadSetting()
{
	faceType = setting.get(dget_id, L"faceType", 0);
	hour24 = setting.get(dget_id, L"hour24", false);
	outSec = setting.get(dget_id, L"outSec", true);
	digit2 = setting.get(dget_id, L"digit2", true);
}
void CClock::SaveSetting()
{
	setting.set(dget_id, L"faceType", faceType);
	setting.set(dget_id, L"hour24", hour24);
	setting.set(dget_id, L"outSec", outSec);
	setting.set(dget_id, L"digit2", digit2);
}

INT_PTR CALLBACK CClock::ClockDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CClock* pWidget;
	int radio = 0;
	static LPCTSTR arFace[] = { TEXT(""),TEXT("Ƴα") };
	ULONGLONG tick;
	int Min, Hour, Day;
	TCHAR str[255];
	SYSTEMTIME st, boot;
	DWORD abs;

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CClock*)lParam;
		RECT wrt;
		GetWindowRect(pWidget->win_hWnd, &wrt);
		MovePopupToSide(hDlg, wrt.left, wrt.top);

		for (int i = 0; i < Count(arFace); i++) {
			SendDlgItemMessage(hDlg, IDC_CLOCKFACE, LB_ADDSTRING, 0, (LPARAM)arFace[i]);
		}
		SendDlgItemMessage(hDlg, IDC_CLOCKFACE, LB_SETCURSEL, pWidget->faceType, 0);

		SendDlgItemMessage(hDlg, IDC_CHKHOUR24, BM_SETCHECK, pWidget->hour24 ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKOUTSEC, BM_SETCHECK, pWidget->outSec ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKDIGIT2, BM_SETCHECK, pWidget->digit2 ? BST_CHECKED : BST_UNCHECKED, 0);

		tick = GetTickCount64() / 1000;
		Day = int(tick / 86400);
		Hour = (tick % 86400) / 3600;
		Min = (tick % 3600) / 60;

		GetLocalTime(&st);
		abs = MyGetAbsSecond(st);
		MyAbsSecondToSystem(DWORD(abs - tick), boot);

		wsprintf(str, TEXT("%d/%d %d:%d (%d %dð %d)"), boot.wMonth, boot.wDay, boot.wHour, boot.wMinute, Day, Hour, Min);
		SetDlgItemText(hDlg, IDC_STBOOT, str);

		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			pWidget->hour24 = IsDlgButtonChecked(hDlg, IDC_CHKHOUR24);
			pWidget->outSec = IsDlgButtonChecked(hDlg, IDC_CHKOUTSEC);
			pWidget->digit2 = IsDlgButtonChecked(hDlg, IDC_CHKDIGIT2);
			pWidget->faceType = (int)SendDlgItemMessage(hDlg, IDC_CLOCKFACE, LB_GETCURSEL, 0, 0);
			InvalidateRect(pWidget->win_hWnd, NULL, TRUE);

			//  Ѵ. Ź ϴ ͺٴ   ϴ°   δ. 
			pWidget->SaveSetting();

			// ⼭ ıϸ WM_NCACTIVATE .      ıؾ Ѵ.
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			// ESC ư   Ѵ.
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CRadix::OnCreate(WPARAM wParam, LPARAM lParam)
{
	editByCode = false;

	//  Ʈ ID  Ѵ.
	hEdit2 = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER |
		ES_AUTOHSCROLL, 0, 0, 0, 0, win_hWnd, (HMENU)2, g_hInst, NULL);
	hEdit10 = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER |
		ES_AUTOHSCROLL, 0, 0, 0, 0, win_hWnd, (HMENU)10, g_hInst, NULL);
	hEdit16 = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER |
		ES_AUTOHSCROLL, 0, 0, 0, 0, win_hWnd, (HMENU)16, g_hInst, NULL);
	return 0;
}

LRESULT CRadix::OnSize(WPARAM wParam, LPARAM lParam)
{
	CWindow::OnSize(wParam, lParam);
	int width = LOWORD(lParam);
	int height = HIWORD(lParam);
	int center;

	// 2 10   ߰ ߾ ǥ ´.
	//  100  ̺ 13ȼ   Ű ´  ߾ Ѵ.
	if (width > 100) {
		center = height / 2 + 3;
	} else {
		center = height / 2 - 10;
	}

	//  ߾  2  25ø 10, 16 ߾ӿ . ̴  20
	// 2  20,  5ŭ  10 ݱ, 16   
	MoveWindow(hEdit2, 20, center - 25, width - 25, 20, TRUE);
	if (width > 100) {
		MoveWindow(hEdit10, 20, center, width / 2 - 20, 20, TRUE);
		MoveWindow(hEdit16, width / 2 + 25, center, width / 2 - 30, 20, TRUE);
	} else {
		//  100  10, 16   Ѵ.
		MoveWindow(hEdit10, 20, center, width - 25, 20, TRUE);
		MoveWindow(hEdit16, 20, center + 25, width - 25, 20, TRUE);
	}
	SendMessage(hEdit2, WM_SETFONT, (WPARAM)mainFont[1], MAKELPARAM(FALSE, 0));
	SendMessage(hEdit10, WM_SETFONT, (WPARAM)mainFont[1], MAKELPARAM(FALSE, 0));
	SendMessage(hEdit16, WM_SETFONT, (WPARAM)mainFont[1], MAKELPARAM(FALSE, 0));

	return 0;
}

void CRadix::OnDraw(HDC hdc, int width, int height)
{
	HFONT oldFont;
	int center;

	if (width > 100) {
		center = height / 2 + 3;
	} else {
		center = height / 2 - 10;
	}

	oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
	SetBkMode(hdc, TRANSPARENT);
	SetTextAlign(hdc, TA_CENTER);

	// ĸ  ׸. 
	TextOutVCenter(hdc, 10, center - 12, L"2");
	TextOutVCenter(hdc, 10, center + 10, L"10");
	if (width > 100) {
		TextOutVCenter(hdc, width / 2 + 15, center + 10, L"16");
	} else {
		TextOutVCenter(hdc, 10, center + 35, L"16");
	}

	SelectObject(hdc, oldFont);
}

LRESULT CRadix::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int num;
	TCHAR str[128];

	switch (LOWORD(wParam)) {
	case 10:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			if (editByCode == false) {
				editByCode = TRUE;
				num = GetDlgItemInt(win_hWnd, 10, NULL, FALSE);
				memset(str, 0, 128 * sizeof(TCHAR));
				_itot_s<128>(num, str, 16);
				SetDlgItemText(win_hWnd, 16, str);
				_itot_s<128>(num, str, 2);
				SetDlgItemText(win_hWnd, 2, str);
				editByCode = FALSE;
			}
			return TRUE;
		}
		break;
	case 16:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			if (editByCode == false) {
				editByCode = TRUE;
				GetDlgItemText(win_hWnd, 16, str, 128);
				num = _tcstoul(str, NULL, 16);
				SetDlgItemInt(win_hWnd, 10, num, FALSE);
				_itot_s<128>(num, str, 2);
				SetDlgItemText(win_hWnd, 2, str);
				editByCode = FALSE;
			}
			return TRUE;
		}
		break;
	case 2:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			if (editByCode == false) {
				editByCode = TRUE;
				GetDlgItemText(win_hWnd, 2, str, 128);
				num = _tcstoul(str, NULL, 2);
				SetDlgItemInt(win_hWnd, 10, num, FALSE);
				_itot_s<128>(num, str, 16);
				SetDlgItemText(win_hWnd, 16, str);
				editByCode = FALSE;
			}
			return TRUE;
		}
		break;
	}
	return 0;
}

LRESULT CCpuUsage::OnCreate(WPARAM wParam, LPARAM lParam) {
	LoadSetting();
	SetTimer(win_hWnd, 1, timerInterval * 1000, NULL);
	SendMessage(win_hWnd, WM_TIMER, 1, NULL);
	PdhOpenQuery(NULL, NULL, &cpuQuery);
	PdhAddCounter(cpuQuery, TEXT("\\Processor(_Total)\\% Processor Time"), NULL, &cpuTotal);
	PdhCollectQueryData(cpuQuery);

	memset(arUsage, 0, sizeof(arUsage));
	return 0;
}

LRESULT CCpuUsage::OnDestroy(WPARAM wParam, LPARAM lParam) {
	KillTimer(win_hWnd, 1);
	return 0;
}

LRESULT CCpuUsage::OnTimer(WPARAM wParam, LPARAM lParam) {
	PDH_FMT_COUNTERVALUE counterVal;

	//  ĭ ֱٰ 
	PdhCollectQueryData(cpuQuery);
	PdhGetFormattedCounterValue(cpuTotal, PDH_FMT_DOUBLE, NULL, &counterVal);

	// ϳ  ̵ϰ  ֱٰ 
	for (int i = 1; i < USAGE_NUM; i++) {
		arUsage[i - 1] = arUsage[i];
	}
	arUsage[USAGE_NUM - 1] = counterVal.doubleValue;

	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

void CCpuUsage::OnDraw(HDC hdc, int width, int height) {
	// 60  + , , » 
	POINT pts[USAGE_NUM + 3];
	double Min = 100, Max = 0, Sum = 0, Avg;
	HPEN hPen, OldPen;
	HBRUSH hBrush, OldBrush;
	HFONT OldFont;
	TCHAR sUsage[128];
	TCHAR yMax[10];
	RECT trt;
	RECT grt;
	int twidth, theight;
	int tleft, tright;

	SetBkMode(hdc, TRANSPARENT);

	// Ʈ 簢
	SetRect(&trt, 18, 5, width - 5, height - 35);
	// ׷  Ʈ 簢 1ȼ  
	CopyRect(&grt, &trt);
	InflateRect(&grt, -1, -1);
	twidth = (grt.right - grt.left);
	theight = (grt.bottom - grt.top);

	// Ʈ 簢 ׸.
	hPen = CreatePen(PS_SOLID, 1, RGB(16, 80, 160));
	OldPen = (HPEN)SelectObject(hdc, hPen);
	hBrush = CreateSolidBrush(RGB(240, 240, 255));
	OldBrush = (HBRUSH)SelectObject(hdc, hBrush);
	Rectangle(hdc, trt.left, trt.top, trt.right, trt.bottom);
	SelectObject(hdc, OldPen);
	DeleteObject(hPen);
	SelectObject(hdc, OldBrush);
	DeleteObject(hBrush);

	// ׷  ٵ .
	hPen = CreatePen(PS_SOLID, 1, RGB(220, 220, 255));
	OldPen = (HPEN)SelectObject(hdc, hPen);
	for (int i = 1; i <= 3; i++) {
		MoveToEx(hdc, trt.left + 1, trt.top + theight * i / 4, NULL);
		LineTo(hdc, trt.right - 1, trt.top + theight * i / 4);
	}
	for (int i = 1; i <= 5; i++) {
		MoveToEx(hdc, trt.left + twidth * i / 6, trt.top + 1, NULL);
		LineTo(hdc, trt.left + twidth * i / 6, trt.bottom - 1);
	}
	SelectObject(hdc, OldPen);
	DeleteObject(hPen);

	// 踦 Ѵ. տ 0%    ̾ Ѵ.
	int validCount = 0;
	for (int i = 0; i < USAGE_NUM; i++) {
		Min = min(Min, arUsage[i]);
		Max = max(Max, arUsage[i]);
		Sum = Sum + arUsage[i];
		if (arUsage[i] != 0) validCount++;
	}
	if (validCount == 0) {
		Avg = 0;
	} else {
		Avg = Sum / validCount;
	}

	//  Y ɼ .  40% ̸̸ 50, 20̸̸ 25, 10̸̸ 12 y  Ѵ.
	//  Y̸  100%̴.
	int topValue = 100;
	if (varYAxis) {
		if (Max < 10) {
			topValue = 12;
		} else if (Max < 20) {
			topValue = 25;
		} else if (Max < 40) {
			topValue = 50;
		}
	}
	wsprintf(yMax, L"%d", topValue);

	// ٰ . topValue 簢 ܿ . 
	for (int i = 0; i < USAGE_NUM; i++) {
		pts[i].x = LONG(grt.left + (double)twidth * i / ((double)USAGE_NUM - 1));
		pts[i].y = LONG(grt.top + theight - theight * arUsage[i] / topValue);
	}
	pts[USAGE_NUM].x = pts[USAGE_NUM - 1].x;
	pts[USAGE_NUM].y = grt.top + theight;
	pts[USAGE_NUM + 1].x = grt.left;
	pts[USAGE_NUM + 1].y = grt.top + theight;
	pts[USAGE_NUM + 2].x = pts[0].x;
	pts[USAGE_NUM + 2].y = pts[0].y;

	// ٰ ׸.
	Polygon(hdc, pts, USAGE_NUM + 3);

	// Y ̺ Ѵ.
	OldFont = (HFONT)SelectObject(hdc, mainFont[0]);
	UINT oldAlign = SetTextAlign(hdc, TA_RIGHT);
	TextOutVCenter(hdc, 16, trt.bottom, L"0");
	TextOutVCenter(hdc, 16, trt.top, yMax);
	SetTextAlign(hdc, oldAlign);

	// Ʈ ¿  ߵ     ¦ δ.
	tleft = trt.left;
	tright = width - 3;
	if (width < 120) {
		tleft = 2;
		tright = width;
	}

	// 谪  ȯϿ Ѵ.
	OldFont = (HFONT)SelectObject(hdc, mainFont[1]);
	wsprintf(sUsage, L":%d~%d", (int)Min, (int)Max);
	TextOutSz(hdc, tleft, trt.bottom + 2, sUsage);
	wsprintf(sUsage, L":%d%%", (int)Avg);
	TextOutSz(hdc, tleft, trt.bottom + 18, sUsage);
	SelectObject(hdc, OldFont);
	OldFont = (HFONT)SelectObject(hdc, mainFont[2]);
	oldAlign = SetTextAlign(hdc, TA_RIGHT);
	SetTextColor(hdc, RGB(0, 128, 0));
	wsprintf(sUsage, L"%d%%", (int)arUsage[USAGE_NUM - 1]);
	TextOutSz(hdc, tright, trt.bottom + 5, sUsage);
	SetTextAlign(hdc, oldAlign);
	SelectObject(hdc, OldFont);
}

LRESULT CCpuUsage::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_CPUUSAGE),
			win_hWnd, CpuUsageDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}
	return 0;
}

void CCpuUsage::LoadSetting()
{
	timerInterval = setting.get(dget_id, L"timerInterval", 5);
	varYAxis = setting.get(dget_id, L"varYAxis", 1);
	viewThread = setting.get(dget_id, L"viewThread", 0);
}

void CCpuUsage::SaveSetting()
{
	setting.set(dget_id, L"timerInterval", timerInterval);
	setting.set(dget_id, L"varYAxis", varYAxis);
	setting.set(dget_id, L"viewThread", viewThread);
}

INT_PTR CALLBACK CCpuUsage::CpuUsageDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CCpuUsage* pWidget;
	int radio = 0;

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CCpuUsage*)lParam;
		RECT wrt;
		GetWindowRect(pWidget->win_hWnd, &wrt);
		MovePopupToSide(hDlg, wrt.left, wrt.top);

		if (pWidget->timerInterval == 1) radio = IDC_CPUTIME1;
		if (pWidget->timerInterval == 2) radio = IDC_CPUTIME2;
		if (pWidget->timerInterval == 5) radio = IDC_CPUTIME3;
		if (pWidget->timerInterval == 10) radio = IDC_CPUTIME4;
		CheckRadioButton(hDlg, IDC_CPUTIME1, IDC_CPUTIME4, radio);

		SendDlgItemMessage(hDlg, IDC_CHKVARYAXIS, BM_SETCHECK,
			pWidget->varYAxis ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKVIEWTHREAD, BM_SETCHECK,
			pWidget->viewThread ? BST_CHECKED : BST_UNCHECKED, 0);

		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			if (IsDlgButtonChecked(hDlg, IDC_CPUTIME1)) pWidget->timerInterval = 1;
			if (IsDlgButtonChecked(hDlg, IDC_CPUTIME2)) pWidget->timerInterval = 2;
			if (IsDlgButtonChecked(hDlg, IDC_CPUTIME3)) pWidget->timerInterval = 5;
			if (IsDlgButtonChecked(hDlg, IDC_CPUTIME4)) pWidget->timerInterval = 10;
			SetTimer(pWidget->win_hWnd, 1, pWidget->timerInterval * 1000, NULL);
			pWidget->varYAxis = IsDlgButtonChecked(hDlg, IDC_CHKVARYAXIS);
			pWidget->viewThread = IsDlgButtonChecked(hDlg, IDC_CHKVIEWTHREAD);
			InvalidateRect(pWidget->win_hWnd, NULL, TRUE);

			pWidget->SaveSetting();

			hOptionPopup = NULL;
			DestroyWindow(hDlg);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CMemUsage::OnCreate(WPARAM wParam, LPARAM lParam) {
	timerInterval = 10;
	SetTimer(win_hWnd, 1, timerInterval * 1000, NULL);
	SendMessage(win_hWnd, WM_TIMER, 1, 0);
	return 0;
}

LRESULT CMemUsage::OnDestroy(WPARAM wParam, LPARAM lParam) {
	KillTimer(win_hWnd, 1);
	return 0;
}

LRESULT CMemUsage::OnTimer(WPARAM wParam, LPARAM lParam) {
	mem.dwLength = sizeof(MEMORYSTATUSEX);
	GlobalMemoryStatusEx(&mem);
	InvalidateRect(win_hWnd, NULL, FALSE);
	return 0;
}

void CMemUsage::OnDraw(HDC hdc, int width, int height)
{
	TCHAR str[128];
	HFONT oldFont;
	UINT oldAlign;
	double total = mem.ullTotalPhys / 1073741824.0;
	double avail = mem.ullAvailPhys / 1073741824.0;
	double used = total - avail;
	int center = height / 2;

	SetBkMode(hdc, TRANSPARENT);
	if (width < 100) {
		oldFont = (HFONT)SelectObject(hdc, mainFont[0]);
	} else {
		oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
	}
	oldAlign = SetTextAlign(hdc, TA_BASELINE);
	_stprintf_s(str, TEXT("%.1fG"), total);
	TextOutSz(hdc, 4, center - 2, str);
	SetTextAlign(hdc, TA_TOP);
	_stprintf_s(str, TEXT("%.1fG"), used);
	TextOutSz(hdc, 4, center + 2, str);

	if (width < 100) {
		SelectObject(hdc, mainFont[1]);
	} else {
		SelectObject(hdc, mainFont[2]);
	}
	_stprintf_s(str, TEXT("%d%%"), mem.dwMemoryLoad);
	SetTextAlign(hdc, TA_RIGHT);
	SetTextColor(hdc, RGB(0, 0, 255));
	TextOutVCenter(hdc, width - 4, center, str);
	SelectObject(hdc, oldFont);
	SetTextAlign(hdc, oldAlign);
}

LRESULT CBattery::OnCreate(WPARAM wParam, LPARAM lParam) {
	SetTimer(win_hWnd, 1, 10000, NULL);
	SendMessage(win_hWnd, WM_TIMER, 1, 0);
	return 0;
}

LRESULT CBattery::OnDestroy(WPARAM wParam, LPARAM lParam) {
	KillTimer(win_hWnd, 1);
	return 0;
}

LRESULT CBattery::OnTimer(WPARAM wParam, LPARAM lParam)
{
	GetSystemPowerStatus(&sps);
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

void CBattery::OnDraw(HDC hdc, int width, int height)
{
	HFONT oldFont;
	HBRUSH brush, oldbrush;
	brush = CreateSolidBrush(RGB(255, 0, 0));
	UINT oldAlign;
	SetBkMode(hdc, TRANSPARENT);

	TCHAR ac[128];
	TCHAR remain[128] = L"";
	TCHAR percent[128];
	if (sps.ACLineStatus) {
		lstrcpy(ac, L" ");
	} else {
		if (sps.BatteryLifeTime != (DWORD)-1) {
			if (sps.BatteryLifeTime >= 3600) {
				wsprintf(remain, L"%d:%d", sps.BatteryLifeTime / 3600, sps.BatteryLifeTime % 3600 / 60);
			} else {
				wsprintf(remain, L"%d", sps.BatteryLifeTime % 3600 / 60);
			}
			wsprintf(ac, L"͸(%s)", remain);
		} else {
			lstrcpy(ac, L"͸");
		}
	}
	wsprintf(percent, L"%d%%", sps.BatteryLifePercent);

	if (width < 100) {
		oldFont = (HFONT)SelectObject(hdc, mainFont[0]);
	} else {
		oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
	}
	if (mainWindow.bVertical) {
		TextOutVCenter(hdc, 5, height / 4, ac);
	} else {
		oldAlign = SetTextAlign(hdc, TA_CENTER);
		TextOutSz(hdc, width / 4, height / 4, ac);
		SetTextAlign(hdc, oldAlign);
	}

	if (width < 100) {
		SelectObject(hdc, mainFont[1]);
	} else {
		SelectObject(hdc, mainFont[2]);
	}

	if (mainWindow.bVertical) {
		oldAlign = SetTextAlign(hdc, TA_RIGHT);
		TextOutVCenter(hdc, width - 5, height / 4, percent);
		SetTextAlign(hdc, oldAlign);

		// ¿ ڿ    20 ߾ 
		Rectangle(hdc, 5, height / 2, width - 5, height / 2 + 20);
		int twidth = width - 14;
		int gaugewidth = sps.BatteryLifePercent * twidth / 100;
		oldbrush = (HBRUSH)SelectObject(hdc, brush);
		Rectangle(hdc, 5, height / 2 + 2, 7 + gaugewidth, height / 2 + 20 - 2);
		SelectObject(hdc, oldbrush);
	} else {
		oldAlign = SetTextAlign(hdc, TA_CENTER);
		TextOutSz(hdc, width / 4, height / 2, percent);
		SetTextAlign(hdc, oldAlign);

		int gcenter = width * 3 / 4;
		Rectangle(hdc, gcenter - 10, 5, gcenter + 10, height - 5);
		int theight = height - 14;
		int gaugeheight = sps.BatteryLifePercent * theight / 100;
		oldbrush = (HBRUSH)SelectObject(hdc, brush);
		Rectangle(hdc, gcenter - 8, height - 5 - gaugeheight, gcenter + 8, height - 5);
		SelectObject(hdc, oldbrush);
	}

	DeleteObject(brush);
	SelectObject(hdc, oldFont);
}

LRESULT CDiskUsage::OnCreate(WPARAM wParam, LPARAM lParam) {
	timerInterval = setting.get(dget_id, L"timerInterval", 60);
	includeRemovable = setting.get(dget_id, L"includeRemovable", 1);
	includeNetwork = setting.get(dget_id, L"includeNetwork", 0);
	relativeChart = setting.get(dget_id, L"relativeChart", 1);
	SetTimer(win_hWnd, 1, timerInterval * 1000, NULL);
	SendMessage(win_hWnd, WM_TIMER, 1, 0);
	return 0;
}

LRESULT CDiskUsage::OnDestroy(WPARAM wParam, LPARAM lParam) {
	KillTimer(win_hWnd, 1);
	return 0;
}

LRESULT CDiskUsage::OnTimer(WPARAM wParam, LPARAM lParam)
{
	TCHAR Drive[MAX_PATH];
	UINT Type;
	int idx = 0;

	for (int i = 'C'; i <= 'Z'; i++) {
		wsprintf(Drive, L"%c:\\", i);
		Type = GetDriveType(Drive);
		if (Type == DRIVE_FIXED || (includeRemovable && Type == DRIVE_REMOVABLE)
			|| (includeNetwork && Type == DRIVE_REMOTE)) {
			arDisk[idx].drive = i;
			GetDiskFreeSpaceEx(Drive, &arDisk[idx].Avail, &arDisk[idx].Total, NULL);
			idx++;
		}
	}
	//  ǥ
	arDisk[idx].drive = '0';
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

void CDiskUsage::OnDraw(HDC hdc, int width, int height)
{
	TCHAR str[111];
	HFONT oldFont;
	int y;
	int maxTotal = 0;
	HBRUSH uesdGraph;
	RECT urt;
	const int Thick = 12;
	HPEN pen, oldPen;

	oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
	SetBkMode(hdc, TRANSPARENT);
	uesdGraph = CreateSolidBrush(RGB(0, 255, 0));
	pen = CreatePen(PS_SOLID, 1, RGB(192, 192, 192));
	oldPen = (HPEN)SelectObject(hdc, pen);

	// ִ 뷮 ã´.
	for (int idx = 0; arDisk[idx].drive != '0'; idx++) {
		int total = int(arDisk[idx].Total.QuadPart / 1073741824);
		if (total > maxTotal) maxTotal = total;
	}

	y = 2 + 7;
	for (int idx = 0; arDisk[idx].drive != '0'; idx++) {
		wsprintf(str, L"%c", arDisk[idx].drive);
		TextOutVCenter(hdc, 2, y, str);

		int total = int(arDisk[idx].Total.QuadPart / 1073741824);
		int avail = int(arDisk[idx].Avail.QuadPart / 1073741824);
		int used = total - avail;

		//  20,  5ŭ   ׷ ׸
		int gwidth = width - 25;
		//  ̺ ׷ 
		int dwidth;
		if (relativeChart) {
			dwidth = gwidth * total / maxTotal;
		} else {
			dwidth = gwidth;
		}

		// ׷ ܰ ׸
		Rectangle(hdc, 20, y - Thick / 2, 20 + dwidth, y + Thick / 2);
		// 뷮 . ׷ 輱 ʿ ׸.
		int uwidth = (dwidth - 2) * used / total;
		SetRect(&urt, 21, y - (Thick / 2 - 1), 21 + uwidth, y + (Thick / 2 - 1));
		FillRect(hdc, &urt, uesdGraph);

		y += 15;
		//  140 ̻  M   
		if (width > 140) {
			wsprintf(str, L"%dM-%dM=%dM(%d%%)", total, used, avail, avail * 100 / total);
		} else {
			if (width < 100) {
				SelectObject(hdc, mainFont[0]);
			}
			wsprintf(str, L"%d-%d=%d", total, used, avail);
		}
		TextOutVCenter(hdc, 2, y, str);
		y += 15 + 5;
	}
	SelectObject(hdc, oldFont);
	DeleteObject(uesdGraph);
	DeleteObject(SelectObject(hdc, oldPen));
}

LRESULT CDiskUsage::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_DISKUSAGE),
			win_hWnd, DiskUsageDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}
	return 0;
}

void CDiskUsage::LoadSetting()
{
	timerInterval = setting.get(dget_id, L"timerInterval", 60);
	includeRemovable = setting.get(dget_id, L"includeRemovable", 1);
	includeNetwork = setting.get(dget_id, L"includeNetwork", 0);
	relativeChart = setting.get(dget_id, L"relativeChart", 1);
}

void CDiskUsage::SaveSetting()
{
	setting.set(dget_id, L"timerInterval", timerInterval);
	setting.set(dget_id, L"includeRemovable", includeRemovable);
	setting.set(dget_id, L"includeNetwork", includeNetwork);
	setting.set(dget_id, L"relativeChart", relativeChart);
}

INT_PTR CALLBACK CDiskUsage::DiskUsageDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CDiskUsage* pWidget;
	int radio = 0;

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CDiskUsage*)lParam;
		RECT wrt;
		GetWindowRect(pWidget->win_hWnd, &wrt);
		MovePopupToSide(hDlg, wrt.left, wrt.top);

		SendDlgItemMessage(hDlg, IDC_CHKRELATIVECHART, BM_SETCHECK,
			pWidget->relativeChart ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKREMOVABLE, BM_SETCHECK,
			pWidget->includeRemovable ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKNETWORK, BM_SETCHECK,
			pWidget->includeNetwork ? BST_CHECKED : BST_UNCHECKED, 0);

		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			pWidget->relativeChart = IsDlgButtonChecked(hDlg, IDC_CHKRELATIVECHART);
			pWidget->includeRemovable = IsDlgButtonChecked(hDlg, IDC_CHKREMOVABLE);
			pWidget->includeNetwork = IsDlgButtonChecked(hDlg, IDC_CHKNETWORK);
			SendMessage(pWidget->win_hWnd, WM_TIMER, 1, 0);
			InvalidateRect(pWidget->win_hWnd, NULL, TRUE);

			pWidget->SaveSetting();

			hOptionPopup = NULL;
			DestroyWindow(hDlg);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

WNDPROC CCalc::CalcOldEditProc;
LRESULT CCalc::OnCreate(WPARAM wParam, LPARAM lParam) {
	hCbExp = CreateWindow(TEXT("combobox"), TEXT(""),
		WS_CHILD | WS_VISIBLE | CBS_DROPDOWN | CBS_AUTOHSCROLL,
		2, 2, 160, 125, win_hWnd, (HMENU)1, g_hInst, NULL);
	SendMessage(hCbExp, WM_SETFONT, (WPARAM)mainFont[1], MAKELPARAM(FALSE, 0));
	// ޺  Ʈ ŬϿ EnterŰ Է Ѵ.
	hEdit = GetWindow(hCbExp, GW_CHILD);
	CCalc::CalcOldEditProc = (WNDPROC)SetWindowLongPtr(hEdit, GWLP_WNDPROC, (LONG_PTR)EditProc);

	calcResult = 0;
	lstrcpy(sResult, L"=0");
	autoCopy = false;

	//  ư
	hBtnCopy = CreateWindow(TEXT("GrpBtn"), NULL, WS_CHILD | WS_VISIBLE | GBS_PUSH,
		0, 0, 16, 16, win_hWnd, (HMENU)2, g_hInst, NULL);
	SendMessage(hBtnCopy, GBM_SETIMAGE, MAKEWPARAM(IDB_CALCCOPYUP, IDB_CALCCOPYHOT),
		MAKEWPARAM(IDB_CALCCOPYDOWN, IDB_CALCCOPYUP));
	return 0;
}

LRESULT CCalc::OnSize(WPARAM wParam, LPARAM lParam)
{
	// ϴ θ ޼带  ȣϿ Ʈ óѴ.
	CWindow::OnSize(wParam, lParam);

	RECT crt;
	GetClientRect(win_hWnd, &crt);

	//  ߾ ϵ  ּ 2ȼ . 
	int y = (crt.bottom - 52) / 2;
	if (y < 2) y = 2;
	MoveWindow(hCbExp, 2, y, crt.right - 4, 125, TRUE);
	y += 25 + 2;
	MoveWindow(hBtnCopy, crt.right - 18, y, 16, 16, TRUE);

	return 0;
}

LRESULT CCalc::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch (LOWORD(wParam)) {
	case 2:
		CopyResult();
		break;
	case IDM_CALC_RESULTUP:
		SendMessage(win_hWnd, WM_USER + 2, 0, 0);
		break;
	case IDM_CALC_AUTOCOPY:
		autoCopy = !autoCopy;
		break;
	}
	return 0;
}

void CCalc::OnDraw(HDC hdc, int width, int height)
{
	HFONT oldFont;

	//  ư   ġ Ѵ.
	RECT wrt;
	GetWindowRect(hBtnCopy, &wrt);
	ScreenToClient(win_hWnd, (LPPOINT)&wrt.left);

	oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
	SetBkMode(hdc, TRANSPARENT);
	TextOutSz(hdc, 2, wrt.top, sResult);
	SelectObject(hdc, oldFont);
}

LRESULT CCalc::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	HMENU hMenu, hPopup;
	hMenu = LoadMenu(g_hInst, MAKEINTRESOURCE(IDR_POPUPMENU));
	hPopup = GetSubMenu(hMenu, 1);

	// ڵ   ޴ ǥ
	if (autoCopy) {
		CheckMenuItem(hPopup, IDM_CALC_AUTOCOPY, MF_BYCOMMAND | MF_CHECKED);
	}

	TrackPopupMenu(hPopup, TPM_LEFTALIGN, (short)LOWORD(lParam),
		(short)HIWORD(lParam), 0, win_hWnd, NULL);
	DestroyMenu(hMenu);
	return 0;
}

//  . Ŭ Ʈ θ Լ ȣ     ޽ ó
LRESULT CCalc::OnUser1(WPARAM wParam, LPARAM lParam)
{
	TCHAR sExp[256];
	BOOL bError;

	GetWindowText(hCbExp, sExp, 256);
	calcResult = CalcExp(sExp, &bError);
	if (bError) {
		lstrcpy(sResult, L" ߸Ǿϴ.");
	} else {
		// ޺ Ͽ .    INI Ͽ   δ ͵   . 
		SendMessage(hCbExp, CB_INSERTSTRING, 0, (LPARAM)sExp);

		_stprintf_s(sResult, TEXT("= %f"), calcResult);
		TrimTrailZero(sResult);

		// ڵ  
		if (autoCopy) {
			CopyResult();
		}
	}
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

//    ø
LRESULT CCalc::OnUser2(WPARAM wParam, LPARAM lParam)
{
	TCHAR str[128];
	HWND hEdit;
	int len;

	_stprintf_s(str, TEXT("%f"), calcResult);
	TrimTrailZero(str);
	lstrcat(str, L" ");
	SetWindowText(hCbExp, str);

	// ڿ  ϳ  ־ ְ  ̵  Ŀ ش. 
	SetFocus(hCbExp);
	hEdit = GetWindow(hCbExp, GW_CHILD);
	len = GetWindowTextLength(hEdit);
	SendMessage(hEdit, EM_SETSEL, len, len);
	return 0;
}

void CCalc::CopyResult()
{
	TCHAR str[128];
	_stprintf_s(str, TEXT("%f"), calcResult);
	TrimTrailZero(str);

	HGLOBAL hmem;
	TCHAR* ptr;
	hmem = GlobalAlloc(GHND, (lstrlen(str) + 1) * sizeof(TCHAR));
	ptr = (TCHAR*)GlobalLock(hmem);
	memcpy(ptr, str, (lstrlen(str) + 1) * sizeof(TCHAR));
	GlobalUnlock(hmem);
	if (OpenClipboard(win_hWnd)) {
		EmptyClipboard();
		SetClipboardData(CF_UNICODETEXT, hmem);
		CloseClipboard();
	} else {
		GlobalFree(hmem);
	}
}

LRESULT CALLBACK CCalc::EditProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	switch (iMessage) {
	case WM_KEYDOWN:
		if (wParam == VK_RETURN) {
			PostMessage(GetParent(GetParent(hWnd)), WM_USER + 1, 0, 0);
			return 0;
		}
		if (wParam == VK_TAB) {
			PostMessage(GetParent(GetParent(hWnd)), WM_USER + 2, 0, 0);
			break;
		}
		break;
	case WM_KEYUP:
	case WM_CHAR:
		if (wParam == VK_RETURN || wParam == VK_TAB) {
			return 0;
		}
		break;
	}

	return CallWindowProc(CCalc::CalcOldEditProc, hWnd, iMessage, wParam, lParam);
}

double CCalc::CalcExp(TCHAR* exp, BOOL* bError/*=NULL*/)
{
	TCHAR Post[256];
	TCHAR* p;
	int count;

	// ȣ ¦ ´ Ȯ. ¦    Ѵ.
	if (bError != NULL) {
		for (p = exp, count = 0; *p; p++) {
			if (*p == '(') count++;
			if (*p == ')') count--;
		}
		*bError = (count != 0);
	}
	if (*bError) return 0;

	// ,  ܿ ʿ ڰ ִ ȮѴ.
	for (TCHAR* p = exp; *p; p++) {
		if (isCalcChar(*p) == false) {
			*bError = TRUE;
			return 0;
		}
	}
	*bError = FALSE;

	MakePostfix(Post, exp);
	return CalcPostfix(Post);
}

double CCalc::CalcPostfix(TCHAR* Post)
{
	TCHAR* p = Post;
	double num;
	double left, right;
	TStack<double> dS(256);

	while (*p) {
		// ڴ ÿ ִ´.
		if (isdigit(*p)) {
			num = _ttof(p);
			dS.Push(num);
			for (; isdigit(*p) || *p == '.'; p++) { ; }
		} else {
			// ڴ ÿ    ϰ ٽ ǪѴ.
			if (strchr("^*/+-", *p)) {
				right = dS.Pop();
				left = dS.Pop();
				switch (*p) {
				case '+':
					dS.Push(left + right);
					break;
				case '-':
					dS.Push(left - right);
					break;
				case '*':
					dS.Push(left * right);
					break;
				case '/':
					if (right == 0.0) {
						dS.Push(0.0);
					} else {
						dS.Push(left / right);
					}
					break;
				case '^':
					dS.Push(pow(left, right));
					break;
				}
			}
			//   Ǵ ڰ ƴ   ڷ
			p++;
		}
	}
	if (dS.GetTop() != -1) {
		num = dS.Pop();
	} else {
		num = 0.0;
	}
	return num;
}

void CCalc::MakePostfix(TCHAR* Post, TCHAR* Mid)
{
	TCHAR* m = Mid;
	TCHAR* p = Post, c;
	TStack<TCHAR> cS(256);

	while (*m) {
		//  - ״ ϰ ڿ  ϳ Ѵ.
		if (isdigit(*m)) {
			while (isdigit(*m) || *m == '.') *p++ = *m++;
			*p++ = ' ';
		} else {
			//  - ÿ ִ ڱ⺸  ڸ   ϰ ڽ ǪѴ.
			if (strchr("^*/+-", *m)) {
				while (cS.GetTop() != -1 && GetPriority(cS.GetValue(cS.GetTop())) >=
					GetPriority(*m)) {
					*p++ = cS.Pop();
				}
				cS.Push(*m++);
			} else {
				//  ȣ - ǪѴ.
				if (*m == '(') {
					cS.Push(*m++);
				} else {
					// ݴ ȣ -  ȣ   ؼ ϰ  ȣ .
					if (*m == ')') {
						for (;;) {
							c = cS.Pop();
							if (c == '(') break;
							*p++ = c;
						}
						m++;
					} else {
						m++;
					}
				}
			}
		}
	}
	// ÿ  ڵ  .
	while (cS.GetTop() != -1) {
		*p++ = cS.Pop();
	}
	*p = 0;
}

int CCalc::GetPriority(int op)
{
	switch (op) {
	case '(':
		return 0;
	case '+':
	case '-':
		return 1;
	case '*':
	case '/':
		return 2;
	case '^':
		return 3;
	}
	return 100;
}

bool CCalc::isCalcChar(TCHAR c)
{
	if (c >= '0' and c <= '9') return true;
	if (c == ' ' || c == '+' || c == '-' || c == '*' || c == '/' || c == '^'
		|| c == '(' || c == ')' || c == '.') return true;

	return false;
}

//   todo
// Ʈ ˾ -   ,  , ̵. ̵ 巡 &   
//  ܿ ,   Ű ϴ  ۼϰ   ó
LRESULT CMusicPlayer::OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam) {
	switch (iMessage)
	{
	case MM_MCINOTIFY:
		switch (wParam) {
		case MCI_NOTIFY_ABORTED:
			// MCI_STOP  ABORTED   ⼭ ġ ݴ´. 
			mciSendCommand(LOWORD(lParam), MCI_CLOSE, 0, (DWORD)NULL);
			dev_id = 0;
			break;
		case MCI_NOTIFY_SUCCESSFUL:
			// Ѱ  Ϸ. ̶ ̹ STOP ̴. ġ     . 
			mciSendCommand(LOWORD(lParam), MCI_CLOSE, 0, (DWORD)NULL);
			dev_id = 0;

			//  ׷   ̵  Ѵ.
			if (randomPlay) {
				playIdx = SelectRandomPlay();
			} else {
				moveNext(playIdx, arMusic[playGroup].size());
			}
			groupIdx[playGroup] = playIdx;
			//  ׷ ̴ ̸ Ʈ ڽ Ŀ Ű ش.
			if (GetActiveGroup() == playGroup) {
				SendMessage(hList, LB_SETCURSEL, playIdx, 0);
			}
			DoPlayCurrent(true);
			break;
		}
		return 0;
	case WM_HSCROLL:
		if (lParam == (LPARAM)hProg) {
			if (dev_id != 0) {
				//  ߰ α׷ ġ ٽ Ѵ. 
				mciSendCommand(dev_id, MCI_STOP, 0, (DWORD)NULL);
				SetTimer(win_hWnd, MPTM_MOVEPOS, 100, NULL);
			}
		}
		return 0;
	case WM_HOTKEY:
		switch (wParam) {
		case 0:
			PostMessage(win_hWnd, WM_COMMAND, MAKEWPARAM(MP_PLAY, 0), 0);
			break;
		}
		return 0;
	}

	return CWindow::OnMessage(iMessage, wParam, lParam);
}

LRESULT CMusicPlayer::OnCreate(WPARAM wParam, LPARAM lParam)
{
	hPlay = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 2, 2, 24, 16, win_hWnd, (HMENU)MP_PLAY, g_hInst, NULL);
	SendMessage(hPlay, GBM_SETIMAGE, MAKEWPARAM(IDB_PLAYUP, IDB_PLAYHOT), MAKEWPARAM(IDB_PLAYDOWN, IDB_PLAYUP));
	hStop = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 28, 2, 16, 16, win_hWnd, (HMENU)MP_STOP, g_hInst, NULL);
	SendMessage(hStop, GBM_SETIMAGE, MAKEWPARAM(IDB_STOPUP, IDB_STOPHOT), MAKEWPARAM(IDB_STOPDOWN, IDB_STOPUP));
	hPrev = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 46, 2, 16, 16, win_hWnd, (HMENU)MP_PREV, g_hInst, NULL);
	SendMessage(hPrev, GBM_SETIMAGE, MAKEWPARAM(IDB_PREVUP, IDB_PREVHOT), MAKEWPARAM(IDB_PREVDOWN, IDB_PREVUP));
	hNext = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 64, 2, 16, 16, win_hWnd, (HMENU)MP_NEXT, g_hInst, NULL);
	SendMessage(hNext, GBM_SETIMAGE, MAKEWPARAM(IDB_NEXTUP, IDB_NEXTHOT), MAKEWPARAM(IDB_NEXTDOWN, IDB_NEXTUP));
	hRandom = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 90, 2, 16, 16, win_hWnd, (HMENU)MP_RANDOM, g_hInst, NULL);
	SendMessage(hRandom, GBM_SETIMAGE, MAKEWPARAM(IDB_MPRANDOMOFF, IDB_MPRANDOMOFF), MAKEWPARAM(IDB_MPRANDOMON, IDB_MPRANDOMOFF));

	// ũ     ʱȭ
	hProg = CreateWindow(L"GrpScrl", NULL, WS_CHILD | WS_VISIBLE | GSS_HORZ, 2, 20, 128, 14, win_hWnd, (HMENU)MP_PROG, g_hInst, NULL);
	SendMessage(hProg, GSM_SETBACKCOLOR, (WPARAM)win_backColor, 0);

	hGroup1 = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 2, 38, 16, 12, win_hWnd, (HMENU)MP_GROUP1, g_hInst, NULL);
	SendMessage(hGroup1, GBM_SETIMAGE, MAKEWPARAM(IDB_GROUP1UP, IDB_GROUP1UP), MAKEWPARAM(IDB_GROUP1DOWN, IDB_GROUP1DOWN));
	hGroup2 = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 18, 38, 16, 12, win_hWnd, (HMENU)MP_GROUP2, g_hInst, NULL);
	SendMessage(hGroup2, GBM_SETIMAGE, MAKEWPARAM(IDB_GROUP2UP, IDB_GROUP2UP), MAKEWPARAM(IDB_GROUP2DOWN, IDB_GROUP2DOWN));
	hGroup3 = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 34, 38, 16, 12, win_hWnd, (HMENU)MP_GROUP3, g_hInst, NULL);
	SendMessage(hGroup3, GBM_SETIMAGE, MAKEWPARAM(IDB_GROUP3UP, IDB_GROUP3UP), MAKEWPARAM(IDB_GROUP3DOWN, IDB_GROUP3DOWN));
	hGroup4 = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE | GBS_CHECK, 50, 38, 16, 12, win_hWnd, (HMENU)MP_GROUP4, g_hInst, NULL);
	SendMessage(hGroup4, GBM_SETIMAGE, MAKEWPARAM(IDB_GROUP4UP, IDB_GROUP4UP), MAKEWPARAM(IDB_GROUP4DOWN, IDB_GROUP4DOWN));

	hAdd = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 0, 0, 16, 16, win_hWnd, (HMENU)MP_ADD, g_hInst, NULL);
	SendMessage(hAdd, GBM_SETIMAGE, MAKEWPARAM(IDB_MPADDUP, IDB_MPADDHOT), MAKEWPARAM(IDB_MPADDDOWN, IDB_MPADDUP));
	hClear = CreateWindow(L"GrpBtn", NULL, WS_CHILD | WS_VISIBLE, 0, 0, 16, 16, win_hWnd, (HMENU)MP_CLEAR, g_hInst, NULL);
	SendMessage(hClear, GBM_SETIMAGE, MAKEWPARAM(IDB_MPCLEARUP, IDB_MPCLEARHOT), MAKEWPARAM(IDB_MPCLEARDOWN, IDB_MPCLEARUP));

	hList = CreateWindow(TEXT("listbox"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER |
		LBS_NOTIFY | WS_VSCROLL | LBS_NOINTEGRALHEIGHT, 2, 50, 120, 100, win_hWnd, (HMENU)MP_LIST, g_hInst, NULL);
	SendMessage(hList, WM_SETFONT, (WPARAM)mainFont[1], MAKELPARAM(FALSE, 0));

	//     ҷ ´.    . 
	// Ǵ  ÷ ΰ ÿ ϰ ϴ    
	LoadMusicList();

	//   ׷ Ͽ Ѵ. Ʈ ù ׷
	playGroup = setting.get(dget_id, L"playGroup", 0);
	playIdx = setting.get(dget_id, L"playIdx", -1);

	//  ׷  ð Ѵ.   쵵 ־ Ʈ  ̴. 
	TCHAR key[32];
	for (int group = 0; group < 4; group++) {
		wsprintf(key, L"groupIdx%d", group);
		groupIdx[group] = setting.get(dget_id, key, -1);
	}
	//  ׷   Ѵ. 3  5   ص ٽ ϸ 3 Ѵ.
	groupIdx[playGroup] = playIdx;

	//    
	randomPlay = setting.get(dget_id, L"randomPlay", 0);
	if (randomPlay) {
		SendMessage(hRandom, GBM_SETSTATE, GB_DOWN, 0);
	}

	//  ׷ ϰ  ä ִ´. 
	ChangeActiveGroup(playGroup, true);
	FillListBox(playGroup);

	DragAcceptFiles(win_hWnd, TRUE);
	dev_id = 0;

	// α׷ ſ Ÿ̸. ֱ Ѵ. 
	SetTimer(win_hWnd, MPTM_PROG, 200, NULL);

	// PauseŰ  Ű Ѵ. ٸ α׷ ̹    ִ. 
	if (RegisterHotKey(win_hWnd, 0, 0, VK_PAUSE) == FALSE) {
		// Ҹ   ˸    Ѵ. 
#ifndef _DEBUG
		MessageBeep(0);
#endif
	}

	// ӽ  θ ̸  д. 
	// todo :    ƴ ޸   ϴ    
	GetModuleFileName(NULL, stripPath, MAX_PATH);
	TCHAR* bs = _tcsrchr(stripPath, '\\');
	*(bs + 1) = 0;
	lstrcat(stripPath, L"SoEnty-temp.mp3");

	return 0;
}

LRESULT CMusicPlayer::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	//  ׷ Ѵ. 
	setting.set(dget_id, L"playGroup", playGroup);
	setting.set(dget_id, L"playIdx", playIdx);
	setting.set(dget_id, L"randomPlay", randomPlay);

	TCHAR key[32];
	//  ׷  idx Ѵ.
	for (int group = 0; group < 4; group++) {
		wsprintf(key, L"groupIdx%d", group);
		setting.set(dget_id, key, groupIdx[group]);
	}

	KillTimer(win_hWnd, MPTM_PROG);
	UnregisterHotKey(win_hWnd, 0);
	return 0;
}

LRESULT CMusicPlayer::OnSize(WPARAM wParam, LPARAM lParam)
{
	CWindow::OnSize(wParam, lParam);

	// ó ô ũⰡ 0ε ̶ ġ . 
	//  ׷ ũ   Ͻ 0 Ǿ  4 پ  . ũ ٿ پ ũ ϴ  ʿ
	int width = LOWORD(lParam);
	if (width == 0) return 0;

	MoveWindow(hProg, 2, 20, width - 4, 14, TRUE);
	MoveWindow(hList, 2, 50, width - 4, HIWORD(lParam) - 48, TRUE);
	MoveWindow(hAdd, width - 36, 34, 16, 16, TRUE);
	MoveWindow(hClear, width - 18, 34, 16, 16, TRUE);

	return 0;
}

LRESULT CMusicPlayer::OnTimer(WPARAM wParam, LPARAM lParam)
{
	switch (wParam) {
		// α׷ .   ֱ 
	case MPTM_PROG:
		if (dev_id != 0) {
			SendMessage(hProg, GSM_SETPOS, GetPosition(), 0);
		}
		break;
		//  Ŭ     
	case MPTM_PLAYACTIVE:
		KillTimer(win_hWnd, MPTM_PLAYACTIVE);
		PlayActiveCurrent();
		break;
		//   ̵
	case MPTM_PLAYNEXT:
		KillTimer(win_hWnd, MPTM_PLAYNEXT);
		DoPlayCurrent(true);
		break;
		//   ̵
	case MPTM_PLAYPREV:
		KillTimer(win_hWnd, MPTM_PLAYPREV);
		DoPlayCurrent(false);
		break;
		//  ġ ̵.  ũ   ġ  
	case MPTM_MOVEPOS:
		KillTimer(win_hWnd, MPTM_MOVEPOS);
		DoPlay(arMusic[playGroup][groupIdx[playGroup]].c_str(), SendMessage(hProg, GSM_GETPOS, 0, 0));
		break;
	}
	return 0;
}

//  ٸ ɼ . 
LRESULT CMusicPlayer::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	return 0;
}

LRESULT CMusicPlayer::OnDropFiles(WPARAM wParam, LPARAM lParam)
{
	TCHAR Path[MAX_PATH];
	int Count, n, addCount = 0;

	Count = DragQueryFile((HDROP)wParam, 0xffffffff, NULL, 0);
	for (n = 0; n < Count; n++) {
		DragQueryFile((HDROP)wParam, n, Path, MAX_PATH);
		AddFile(Path);
	}

	//  Ͽ  巡 ù ° ׸  .  ׸  ¸  ƾ Ѵ. 
	if (groupIdx[GetActiveGroup()] == -1) {
		groupIdx[GetActiveGroup()] = 0;
		SendMessage(hList, LB_SETCURSEL, 0, 0);
	}

	// Ͽ ȭ   Ѵ. 
	SaveMusicList();
	return 0;
}

LRESULT CMusicPlayer::OnCommand(WPARAM wParam, LPARAM lParam)
{
	int group;
	int list_idx;

	switch (LOWORD(wParam)) {
	case MP_PLAY:
		if (dev_id != 0) {
			//  ִ ̸  ¿  Ͻ Ǵ 簳Ѵ.
			switch (GetStatus()) {
			case MCI_MODE_PLAY:
				mciSendCommand(dev_id, MCI_PAUSE, 0, (DWORD)NULL);
				break;
			case MCI_MODE_PAUSE:
				mciSendCommand(dev_id, MCI_RESUME, 0, (DWORD)NULL);
				break;
			}
		} else {
			//    Ƽ ׷   Ѵ.
			// ڰ   Ͽ   ̴. 
			PlayActiveCurrent();
		}
		break;
	case MP_STOP:
		if (dev_id != 0) {
			mciSendCommand(dev_id, MCI_STOP, 0, (DWORD)NULL);
			SendMessage(hProg, GSM_SETPOS, 0, 0);
		}
		break;
	case MP_NEXT:
		//  ƴϸ Ƽ ׷  ̵ϰ Ʈ ڽ ǥ
		if (dev_id == 0) {
			group = GetActiveGroup();
			if (groupIdx[group] != -1) {
				moveNext(groupIdx[group], arMusic[group].size());
				SendMessage(hList, LB_SETCURSEL, groupIdx[group], 0);
			}
		} else {
			if (randomPlay) {
				playIdx = SelectRandomPlay();
			} else {
				//  ׷  ̵. 
				moveNext(playIdx, arMusic[playGroup].size());
			}
			// ׷  ϴ Ѵ. 
			groupIdx[playGroup] = playIdx;
			//  ׷ ̴ ̸ Ʈ ڽ ǥ. ٸ    
			if (GetActiveGroup() == playGroup) {
				SendMessage(hList, LB_SETCURSEL, playIdx, 0);
			}

			//  ϰ  ׷  
			mciSendCommand(dev_id, MCI_STOP, MCI_WAIT, (DWORD)NULL);
			SetTimer(win_hWnd, MPTM_PLAYNEXT, 100, NULL);
		}
		break;
	case MP_PREV:
		if (dev_id == 0) {
			group = GetActiveGroup();
			if (groupIdx[group] != -1) {
				movePrev(groupIdx[group], arMusic[group].size());
				SendMessage(hList, LB_SETCURSEL, groupIdx[group], 0);
			}
		} else {
			if (randomPlay) {
				playIdx = SelectRandomPlay();
			} else {
				movePrev(playIdx, arMusic[playGroup].size());
			}
			groupIdx[playGroup] = playIdx;
			if (GetActiveGroup() == playGroup) {
				SendMessage(hList, LB_SETCURSEL, playIdx, 0);
			}

			mciSendCommand(dev_id, MCI_STOP, MCI_WAIT, (DWORD)NULL);
			SetTimer(win_hWnd, MPTM_PLAYPREV, 100, NULL);
		}
		break;
	case MP_LIST:
		switch (HIWORD(wParam)) {
		case LBN_DBLCLK:
			// Ŭ  . ̸   
			if (dev_id != 0) {
				mciSendCommand(dev_id, MCI_STOP, MCI_WAIT, (DWORD)NULL);
				SetTimer(win_hWnd, MPTM_PLAYACTIVE, 100, NULL);
			} else {
				PlayActiveCurrent();
			}
			break;
		case LBN_SELCHANGE:
			//   Ƽ ׷   Ѵ.
			list_idx = SendMessage(hList, LB_GETCURSEL, 0, 0);
			groupIdx[GetActiveGroup()] = list_idx;
			break;
		}
		break;
	case MP_ADD:
		OPENFILENAME OFN;
		TCHAR* files;
		TCHAR* p;
		TCHAR dir[MAX_PATH];
		TCHAR file[MAX_PATH];
		TCHAR path[MAX_PATH];
		files = (TCHAR*)calloc(32000, sizeof(TCHAR));
		memset(&OFN, 0, sizeof(OPENFILENAME));
		OFN.lStructSize = sizeof(OPENFILENAME);
		OFN.hwndOwner = win_hWnd;
		OFN.lpstrFilter = TEXT(" (mp3, wav)\0*.mp3;*.wav\0");
		OFN.lpstrFile = files;
		OFN.nMaxFile = 320000;
		OFN.Flags = OFN_EXPLORER | OFN_ALLOWMULTISELECT;
		//    Ѳ ߰. 뷫   Ѳ ߰ ϴ. 
		if (GetOpenFileName(&OFN) != 0) {
			p = files;
			lstrcpy(dir, p);
			if (*(p + lstrlen(dir) + 1) == 0) {
				AddFile(dir);
			} else {
				lstrcpy(file, dir);
				for (;;) {
					p = p + lstrlen(file) + 1;
					if (*p == 0)
						break;
					lstrcpy(file, p);
					lstrcpy(path, dir);
					lstrcat(path, L"\\");
					lstrcat(path, file);
					AddFile(path);
				}
			}
		} else {
			if (CommDlgExtendedError() == FNERR_BUFFERTOOSMALL) {
				MessageBox(win_hWnd, TEXT("Ѳ ʹ   ߽ϴ."), TEXT(""), MB_OK);
			}
		}
		SaveMusicList();
		break;
	case MP_CLEAR:
		//  ̸ ϴ Ѵ. 
		if (dev_id != 0) {
			mciSendCommand(dev_id, MCI_STOP, 0, (DWORD)NULL);
			SendMessage(hProg, GSM_SETPOS, 0, 0);
		}

		// Ʈ ڽ 
		SendMessage(hList, LB_RESETCONTENT, 0, 0);

		// ׷  . 
		group = GetActiveGroup();
		arMusic[group].clear();
		groupIdx[group] = -1;

		SaveMusicList();
		break;
	case MP_GROUP1:
	case MP_GROUP2:
	case MP_GROUP3:
	case MP_GROUP4:
		ChangeActiveGroup(LOWORD(wParam) - MP_GROUP1);
		break;
	case MP_RANDOM:
		randomPlay = (SendMessage(hRandom, GBM_GETSTATE, 0, 0) == GB_DOWN);
		break;
	}
	return 0;
}

//  ׷ Ŀ   Ѵ.
// Play ư , Ŭ,  Ŭ 
void CMusicPlayer::PlayActiveCurrent()
{
	playGroup = GetActiveGroup();
	playIdx = groupIdx[playGroup];
	//  ׷    .  Ѵ.
	if (playIdx == -1) return;
	// ׷   ̻ ȣ ȿϴ.  ׷   ϸ playIdx ȿ ġ Ų. 
	//   ׷ playGroup  playIdx  ϰ ־   ó ʿϴ. 
	if (playIdx >= (int)arMusic[playGroup].size()) return;

	DoPlayCurrent(true);
}

// playGroup playIdx ϸ ȣ     ξ Ѵ. 
// н  Ǵ   ã´. MCI ѰӸ ƴ϶ ߸     ־  ʿϴ.
// ׻  ¿  ޼带 ȣؾ ϸ dev_id ׻ 0̴. 
bool CMusicPlayer::DoPlayCurrent(bool bNext)
{
	int oldIdx = playIdx;

	//  ġ     ̵
	while (DoPlay(arMusic[playGroup][playIdx].c_str()) == false) {
		if (bNext) {
			moveNext(playIdx, arMusic[playGroup].size());
		} else {
			movePrev(playIdx, arMusic[playGroup].size());
		}

		//  ׷ ̸ Ʈ ڽ  ġ Ѵ.
		if (playGroup == GetActiveGroup()) {
			SendMessage(hList, LB_SETCURSEL, playIdx, 0);
		}
		// ѹ  ó     ̸     Ѵ. 
		if (playIdx == oldIdx) return false;

		// ణ .
		MessageBeep(0);
		Sleep(300);
	}

	return true;
}

//   Ѵ. fromPos ־  ġ Ѵ.
bool CMusicPlayer::DoPlay(LPCTSTR musicPath, int fromPos /*= 0*/)
{
	DWORD Result;
	MCI_OPEN_PARMS openParam;
	MCI_PLAY_PARMS playParam;
	TCHAR sError[256];

	// ID3 ±׸  ȯ  ϰ ׷   Ѵ. 
	TCHAR tPath[MAX_PATH];
	if (StripID3Tag(musicPath)) {
		lstrcpy(tPath, stripPath);
	} else {
		lstrcpy(tPath, musicPath);
	}

	//    ̸ ġ   Ѵ. 
	// ġ Openϰ ID ߱޹޴´.
	openParam.lpstrDeviceType = L"mpegvideo";
	openParam.lpstrElementName = tPath;
	Result = mciSendCommand(0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT, (DWORD)(LPVOID)&openParam);
	if (Result) {
		// MCI 277  - ID3 ± Ǵ Ÿ  ߻ . ID3 ±  ذ ٸ     ִ. 
		mciGetErrorString(Result, sError, 256);

		//  ݰ и Ѵ. 
		mciSendCommand(dev_id, MCI_CLOSE, 0, (DWORD)NULL);
		return false;
	}
	dev_id = openParam.wDeviceID;

	//  Ѵ. fromPos  ó Ѵ.    .
	playParam.dwCallback = (DWORD)win_hWnd;
	DWORD dwFlag = MCI_NOTIFY;
	if (fromPos != 0) {
		playParam.dwFrom = fromPos;
		dwFlag = dwFlag | MCI_FROM;
	}
	Result = mciSendCommand(dev_id, MCI_PLAY, dwFlag, (DWORD)(LPVOID)&playParam);

	//  ؼ Ʈٷ  Ѵ. ʴ̸ 32Ʈ  ؾ Ѵ.
	SendMessage(hProg, GSM_SETRANGE, 0, GetLength());

	return true;
}

//  ¸ Ѵ. dev_id  ִ ¿ Ѵ.
DWORD CMusicPlayer::GetStatus()
{
	MCI_STATUS_PARMS statusParam;
	DWORD Result;
	TCHAR sError[256];

	statusParam.dwItem = MCI_STATUS_MODE;
	Result = mciSendCommand(dev_id, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)(LPVOID)&statusParam);
	if (Result) {
		mciGetErrorString(Result, sError, 256);
	}

	return statusParam.dwReturn;
}

//  ̸ Ѵ.
DWORD CMusicPlayer::GetLength()
{
	MCI_STATUS_PARMS statusParam;
	DWORD Result;
	TCHAR sError[256];

	statusParam.dwItem = MCI_STATUS_LENGTH;
	Result = mciSendCommand(dev_id, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)(LPVOID)&statusParam);
	if (Result) {
		mciGetErrorString(Result, sError, 256);
	}

	return statusParam.dwReturn;
}

//   ġ Ѵ.
DWORD CMusicPlayer::GetPosition()
{
	MCI_STATUS_PARMS statusParam;
	DWORD Result;
	TCHAR sError[256];

	statusParam.dwItem = MCI_STATUS_POSITION;
	Result = mciSendCommand(dev_id, MCI_STATUS, MCI_STATUS_ITEM, (DWORD)(LPVOID)&statusParam);
	if (Result) {
		mciGetErrorString(Result, sError, 256);
	}

	return statusParam.dwReturn;
}

//  ǥ ׷쿡  ߰Ѵ.
bool CMusicPlayer::AddFile(LPCTSTR Path)
{
	TCHAR ext[MAX_PATH];

	// Ȯڸ ҹڷ ٲ  Ѵ.
	lstrcpy(ext, PathFindExtension(Path));
	_tcslwr_s(ext, MAX_PATH);
	if (lstrcmp(ext, L".mp3") == 0 || lstrcmp(ext, L".wav") == 0) {
		arMusic[GetActiveGroup()].push_back(Path);
		// δ  ϸ ؼ ǥ
		SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)PathFindFileName(Path));
		return true;
	}

	return false;
}

void CMusicPlayer::LoadMusicList()
{
	TCHAR* buf;
	TCHAR* p, * pEnd;
	TCHAR oneFile[MAX_PATH];
	TCHAR key[32];

	int bufSize = MAX_PATH * 1000 * sizeof(TCHAR);
	buf = (TCHAR*)malloc(bufSize);
	for (int group = 0; group < 4; group++) {
		wsprintf(key, L"MusicList%d", group);
		setting.get(dget_id, key, L"", buf, bufSize);
		arMusic[group].clear();
		for (p = buf; *p != 0;) {
			pEnd = _tcsstr(p, L"");
			memset(oneFile, 0, sizeof(oneFile));
			_tcsncpy_s(oneFile, MAX_PATH, p, pEnd - p);
			arMusic[group].push_back(oneFile);
			p = pEnd + 1;
		}
	}
	free(buf);
}

void CMusicPlayer::SaveMusicList()
{
	TCHAR key[32];
	TCHAR* buf;
	int num;

	// 4 ׷   Ѵ.
	for (int group = 0; group < 4; group++) {
		num = arMusic[group].size();
		if (num == 0) {
			//  ϳ   ڿ з̶ Ҵؼ ؾ Ѵ.
			buf = (TCHAR*)calloc(128, sizeof(TCHAR));
		} else {
			buf = (TCHAR*)calloc(MAX_PATH * num, sizeof(TCHAR));
			for (size_t i = 0; i < (int)arMusic[group].size(); i++) {
				lstrcat(buf, arMusic[group][i].c_str());
				lstrcat(buf, L"");
			}
		}
		wsprintf(key, L"MusicList%d", group);
		setting.set(dget_id, key, buf);
		free(buf);
	}
}

// ׷ Ѵ. 
void CMusicPlayer::ChangeActiveGroup(int group, bool init/* = false*/)
{
	ChangeState(hGroup1, GB_DOWN);
	ChangeState(hGroup2, GB_DOWN);
	ChangeState(hGroup3, GB_DOWN);
	ChangeState(hGroup4, GB_DOWN);

	switch (group) {
	case 0:
		ChangeState(hGroup1, GB_NORMAL);
		break;
	case 1:
		ChangeState(hGroup2, GB_NORMAL);
		break;
	case 2:
		ChangeState(hGroup3, GB_NORMAL);
		break;
	case 3:
		ChangeState(hGroup4, GB_NORMAL);
		break;
	}

	//  ǥ ׷    ش. 
	FillListBox(group);
}

// ׷ ȣ Ѵ.
int CMusicPlayer::GetActiveGroup()
{
	if (SendMessage(hGroup1, GBM_GETSTATE, 0, 0) == GB_NORMAL) return 0;
	if (SendMessage(hGroup2, GBM_GETSTATE, 0, 0) == GB_NORMAL) return 1;
	if (SendMessage(hGroup3, GBM_GETSTATE, 0, 0) == GB_NORMAL) return 2;
	if (SendMessage(hGroup4, GBM_GETSTATE, 0, 0) == GB_NORMAL) return 3;

	return -1;
}

// ׷   ä  ð  ش. 
void CMusicPlayer::FillListBox(int group)
{
	SendMessage(hList, LB_RESETCONTENT, 0, 0);
	for (size_t i = 0; i < (int)arMusic[group].size(); i++) {
		SendMessage(hList, LB_ADDSTRING, 0, (LPARAM)PathFindFileName(arMusic[group][i].c_str()));
	}

	SendMessage(hList, LB_SETCURSEL, groupIdx[group], 0);
}

// playGroup ϰ ϳ  ش. 
// todo : ü ׷쿡    ִ. UI ׷찣  ɼ  
// , ,  ׷찣 ̵ϵ ϸ  ϴ. 
int CMusicPlayer::SelectRandomPlay()
{
	// ϳۿ   0̴.
	if (arMusic[playGroup].size() == 1) return 0;

	int idx;
	do {
		idx = random(arMusic[playGroup].size());
	} while (playIdx == idx);

	return idx;
}

bool CMusicPlayer::StripID3Tag(LPCTSTR path)
{
	HANDLE hFile;
	DWORD dwRead, dwWritten;
	DWORD size;
	void* buf = NULL;

	//    ۷ о δ. 
	//   ٸ  ״ е ȯ · Ѵ. 
	hFile = CreateFile(path, GENERIC_READ, 0, NULL,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE) {
		return false;
	}
	size = GetFileSize(hFile, NULL);
	buf = malloc(size);
	ReadFile(hFile, buf, size, &dwRead, NULL);
	CloseHandle(hFile);

	int offset = 0;
	char* p = (char*)buf;

	// ID3 ϸ ±װ ִ ̴. ±׸    ͸ ӽ  . 
	if (p[0] == 'I' && p[1] == 'D' && p[2] == '3') {
		// ± ̴ 6~9Ʈ ֵ synchsafe  Ǿ ִ.
		// ù Ʈ  0̸  7Ʈ ϴ Ʋ̴. 
		offset = int(p[6] * pow(2, 21) + p[7] * pow(2, 14) + p[8] * pow(2, 7) + p[9]);
		// ± ̿  ̴ Ƿ   10ŭ ؾ  ִ ġ ȴ.
		offset += 10;

		//   ġ ӽ  Ѵ. MCI ޸𸮻    ʾ ݵ  ؾ Ѵ.
		//  Ϸ ϵ α׷    ݵ  Ѵ. 
		hFile = CreateFile(stripPath, GENERIC_WRITE, 0, NULL,
			CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL | FILE_ATTRIBUTE_HIDDEN, NULL);
		WriteFile(hFile, p + offset, size - offset, &dwWritten, NULL);
		CloseHandle(hFile);
	}
	free(buf);

	// ȯ θ Ѵ. 
	if (offset == 0) {
		return false;
	} else {
		return true;
	}
}

LRESULT CImageSlide::OnCreate(WPARAM wParam, LPARAM lParam)
{
	pLastViewer = NULL;
	nowImage = NULL;

	LoadSetting();
	LoadImageList();
	//  0 ϱ  -1 Ѵ.
	nowIdx = -1;
	nowImage = NULL;

	DragAcceptFiles(win_hWnd, TRUE);
	SetTimer(win_hWnd, 1, timerInterval * 1000, NULL);
	SendMessage(win_hWnd, WM_TIMER, 1, 0);

	return 0;
}

LRESULT CImageSlide::OnDestroy(WPARAM wParam, LPARAM lParam) {
	KillTimer(win_hWnd, 1);
	if (nowImage != NULL) {
		delete nowImage;
	}
	return 0;
}

void CImageSlide::OnDraw(HDC hdc, int width, int height)
{
	//   ȳ ޽ Ѵ. 
	if (arImage.size() == 0) {
		RECT crt = { 0, 0, width, height };
		InflateRect(&crt, -2, -5);
		SetTextColor(hdc, RGB(255, 255, 0));
		SetBkMode(hdc, TRANSPARENT);
		HFONT oldFont;
		oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
		LPCTSTR mes = L"̹ ̴\r\n׷ (*.jpg, *.png) 巡Ͽ Ͽ ߰Ͻʽÿ.";
		DrawText(hdc, mes, -1, &crt, DT_WORDBREAK);
		SelectObject(hdc, oldFont);
		return;
	}

	DrawImageCenter(hdc, nowImage, width, height, false, win_backBrush);

	// ϸ 
	if (displayFileName) {
		SetTextColor(hdc, RGB(255, 255, 0));
		SetBkMode(hdc, TRANSPARENT);
		SetTextAlign(hdc, TA_CENTER | TA_BASELINE);
		HFONT oldFont;
		oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
		const TCHAR* p = _tcsrchr(arImage[nowIdx].c_str(), '\\');
		p++;
		TextOutSz(hdc, width / 2, height - 2, p);
		SelectObject(hdc, oldFont);
	}
}

LRESULT CImageSlide::OnLButtonDown(WPARAM wParam, LPARAM lParam)
{
	//   Ѵ.
	if (nowIdx == -1) return 0;

	//   ¿ ̹    ̹ ȣ  ˷ ش.
	if (multiViewer == false && pLastViewer != NULL) {
		SendMessage(pLastViewer->win_hWnd, WM_USER + 1, nowIdx, NULL);
	} else {
		CImageViewer* pImgViewer;
		pImgViewer = new CImageViewer();
		pImgViewer->delegateDispose = true;
		pImgViewer->nowIdx = nowIdx;
		pImgViewer->Create(0, this);
		pLastViewer = pImgViewer;
	}

	return 0;
}

LRESULT CImageSlide::OnTimer(WPARAM wParam, LPARAM lParam)
{
	// ̹ ̸ ƹ ͵  ʴ´.
	if (arImage.size() == 0) {
		return 0;
	}

	// ޸ : nowIdx ù  -1 ʱȭǹǷ ̹ ϳۿ  Ʒ ڵ带 ؼ ȵȴ.

	//  ̹ ̵
	if (randomSlide) {
		int oldIdx = nowIdx;
		//     ޶ Ѵ.  ̹ ϳۿ    .
		for (;;) {
			nowIdx = random(arImage.size());
			if (arImage.size() == 1) break;
			if (nowIdx != oldIdx) break;
		}
	} else {
		nowIdx++;
		if (nowIdx >= (int)arImage.size()) {
			nowIdx = 0;
		}
	}

	//  ̹   ٽ 
	if (nowImage != NULL) {
		delete nowImage;
	}
	nowImage = Image::FromFile(arImage[nowIdx].c_str());
	FixImageOrientation(nowImage);
	InvalidateRect(win_hWnd, NULL, TRUE);
	return 0;
}

LRESULT CImageSlide::OnUser1(WPARAM wParam, LPARAM lParam)
{
	//   ¿  ϳ Ǹ     д.
	// ׷ Ŭ ٽ   ִ. 
	if (multiViewer == false) {
		pLastViewer = NULL;
	}
	return 0;
}

LRESULT CImageSlide::OnDropFiles(WPARAM wParam, LPARAM lParam)
{
	TCHAR Path[MAX_PATH];
	int Count, n, addCount = 0;
	int oldCount;
	TCHAR ext[MAX_PATH];

	oldCount = arImage.size();

	Count = DragQueryFile((HDROP)wParam, 0xffffffff, NULL, 0);
	for (n = 0; n < Count; n++) {
		DragQueryFile((HDROP)wParam, n, Path, MAX_PATH);
		// Ȯڸ ҹڷ ٲ  Ѵ.
		lstrcpy(ext, PathFindExtension(Path));
		_tcslwr_s(ext, MAX_PATH);
		if (lstrcmp(ext, L".jpg") == 0 || lstrcmp(ext, L".png") == 0) {
			arImage.push_back(Path);
			addCount++;
		}
	}
	SaveImageList();

	//  ߰ ̹ ٷ ̵ Ѵ. 
	if (addCount != 0) {
		nowIdx = oldCount - 1;
		SendMessage(win_hWnd, WM_TIMER, 1, 0);
	}
	return 0;
}

LRESULT CImageSlide::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_IMAGESLIDE),
			win_hWnd, ImageSlideDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}
	return 0;
}

INT_PTR CALLBACK CImageSlide::ImageSlideDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CImageSlide* pWidget;
	int radio = 0;
	int list_count, list_idx, new_idx;
	TCHAR oneFile[MAX_PATH];

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CImageSlide*)lParam;
		RECT wrt;
		GetWindowRect(pWidget->win_hWnd, &wrt);
		MovePopupToSide(hDlg, wrt.left, wrt.top);

		SendDlgItemMessage(hDlg, IDC_SPINIMAGECYCLE, UDM_SETRANGE, 0, MAKELPARAM(300, 1));
		SetDlgItemInt(hDlg, IDC_EDIMAGECYCLE, pWidget->timerInterval, FALSE);

		SendDlgItemMessage(hDlg, IDC_CHKRANDOMSLIDE, BM_SETCHECK, pWidget->randomSlide ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKDISPLAYFILENAME, BM_SETCHECK, pWidget->displayFileName ? BST_CHECKED : BST_UNCHECKED, 0);
		SendDlgItemMessage(hDlg, IDC_CHKMULTIVIEWER, BM_SETCHECK, pWidget->multiViewer ? BST_CHECKED : BST_UNCHECKED, 0);

		// ̹  о ´. 
		for (int i = 0; i < (int)pWidget->arImage.size(); i++) {
			SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_ADDSTRING, 0, (LPARAM)pWidget->arImage[i].c_str());
		}
		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			pWidget->timerInterval = GetDlgItemInt(hDlg, IDC_EDIMAGECYCLE, NULL, FALSE);
			pWidget->randomSlide = IsDlgButtonChecked(hDlg, IDC_CHKRANDOMSLIDE);
			pWidget->displayFileName = IsDlgButtonChecked(hDlg, IDC_CHKDISPLAYFILENAME);
			pWidget->multiViewer = IsDlgButtonChecked(hDlg, IDC_CHKMULTIVIEWER);
			SetTimer(pWidget->win_hWnd, 1, pWidget->timerInterval * 1000, NULL);

			//  .    Ѵ.
			pWidget->SaveSetting();

			//   籸.       ؾ . 
			pWidget->arImage.clear();
			list_count = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCOUNT, 0, 0);
			for (int i = 0; i < list_count; i++) {
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETTEXT, i, (LPARAM)oneFile);
				pWidget->arImage.push_back(oneFile);
			}

			//  . ȭ Ǵ ӽÿ Ѵ. 
			pWidget->SaveImageList();

			//     ȳ ޽ ٽ ׸ Ѵ.
			if (pWidget->arImage.size() == 0) {
				InvalidateRect(pWidget->win_hWnd, NULL, TRUE);
			}

			// ⼭ ıϸ WM_NCACTIVATE .      ıؾ Ѵ.
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
			// ESC ư   Ѵ.
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		case IDC_BTNIS_RESET:
			SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_RESETCONTENT, 0, 0);
			return TRUE;
		case IDC_BTNIS_DEL:
			list_idx = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCURSEL, 0, 0);
			if (list_idx != -1) {
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_DELETESTRING, list_idx, 0);
				list_count = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCOUNT, 0, 0);
				//  ġ  ϵ    ׸ 
				new_idx = list_idx < list_count ? list_idx : list_count - 1;
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_SETCURSEL, new_idx, 0);
			}
			return TRUE;
			// todo : 巡ؼ ̵ϴ  ʿ. ̹ ̸ Ⱑ ־     . 
		case IDC_BTNIS_UP:
			list_idx = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCURSEL, 0, 0);
			if (list_idx != -1 && list_idx != 0) {
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETTEXT, list_idx, (LPARAM)oneFile);
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_DELETESTRING, list_idx, 0);
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_INSERTSTRING, list_idx - 1, (LPARAM)oneFile);
				new_idx = list_idx - 1;
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_SETCURSEL, new_idx, 0);
			}
			return TRUE;
		case IDC_BTNIS_DOWN:
			list_idx = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCURSEL, 0, 0);
			list_count = (int)SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETCOUNT, 0, 0);
			if (list_idx != -1 && list_idx != list_count - 1) {
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_GETTEXT, list_idx, (LPARAM)oneFile);
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_DELETESTRING, list_idx, 0);
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_INSERTSTRING, list_idx + 1, (LPARAM)oneFile);
				new_idx = list_idx + 1;
				SendDlgItemMessage(hDlg, IDC_LIIMGLIST, LB_SETCURSEL, new_idx, 0);
			}
			return TRUE;
		}
		break;
	}
	return FALSE;
}

void CImageSlide::LoadSetting()
{
	timerInterval = setting.get(dget_id, L"timerInterval", 5);
	randomSlide = setting.get(dget_id, L"randomSlide", false);
	displayFileName = setting.get(dget_id, L"displayFileName", false);
	multiViewer = setting.get(dget_id, L"multiViewer", false);
}

void CImageSlide::SaveSetting()
{
	setting.set(dget_id, L"timerInterval", timerInterval);
	setting.set(dget_id, L"randomSlide", randomSlide);
	setting.set(dget_id, L"displayFileName", displayFileName);
	setting.set(dget_id, L"multiViewer", multiViewer);
}

void CImageSlide::LoadImageList()
{
	TCHAR* buf;
	TCHAR* p, * pEnd;
	TCHAR oneFile[MAX_PATH];

	// ִ 1000 ̳ δ  .  5000    .
	int bufSize = MAX_PATH * 1000 * sizeof(TCHAR);
	buf = (TCHAR*)malloc(bufSize);
	setting.get(dget_id, L"ImageList", L"", buf, bufSize);
	arImage.clear();
	for (p = buf; *p != 0;) {
		pEnd = _tcsstr(p, L"");
		memset(oneFile, 0, sizeof(oneFile));
		_tcsncpy_s(oneFile, MAX_PATH, p, pEnd - p);
		arImage.push_back(oneFile);
		p = pEnd + 1;
	}
	free(buf);
}

void CImageSlide::SaveImageList()
{
	TCHAR* buf;
	int num;

	// INI    ̾ ؼ ȵǴ. 
	//  ߴ INI б Լ      ũ ڷ Ѵ.
	//    0Ʈ Ҵ  Ƿ  ڿ̶ Ҵؾ Ѵ. 
	num = arImage.size();
	if (num == 0) {
		buf = (TCHAR*)calloc(128, sizeof(TCHAR));
	} else {
		buf = (TCHAR*)calloc(MAX_PATH * num, sizeof(TCHAR));
		for (int i = 0; i < (int)arImage.size(); i++) {
			lstrcat(buf, arImage[i].c_str());
			lstrcat(buf, L"");
		}
	}
	setting.set(dget_id, L"ImageList", buf);
	free(buf);
}

// ޸  todo
//  Ʈ GDI   lib ũ. ִ ؽƮ 
// Ŀ   ޺ ڽ ۼ.
// ˾     ̵  

sNamedColor arMemoBack[] = {
	{L"LemonChiffon", 0}, {L"GreenYellow", 0}, {L"DeepSkyBlue", 0},
	{L"Plum", 0}, {L"LightPink", 0}, {L"Snow", 0},
};

sNamedColor arMemoFore[] = {
	{L"Black", 0}, {L"Red", 0}, {L"Blue", 0},
	{L"Magenta", 0}, {L"Maroon", 0}, {L"Indigo", 0},
};

LRESULT CMemo::OnCreate(WPARAM wParam, LPARAM lParam)
{
	hCombo = CreateWindow(TEXT("combobox"), NULL, WS_CHILD | WS_VISIBLE |
		CBS_DROPDOWNLIST, 2, 2, 100, 200, win_hWnd, (HMENU)MEMO_COMBO, g_hInst, NULL);
	hAdd = CreateWindow(TEXT("button"), TEXT("+"), WS_CHILD | WS_VISIBLE |
		BS_PUSHBUTTON, 20, 20, 100, 25, win_hWnd, (HMENU)MEMO_ADD, g_hInst, NULL);
	hDelete = CreateWindow(TEXT("button"), TEXT("-"), WS_CHILD | WS_VISIBLE |
		BS_PUSHBUTTON, 20, 50, 100, 25, win_hWnd, (HMENU)MEMO_DELETE, g_hInst, NULL);
	hView = CreateWindow(TEXT("button"), TEXT(""), WS_CHILD | WS_VISIBLE |
		BS_PUSHBUTTON, 20, 20, 100, 25, win_hWnd, (HMENU)MEMO_VIEW, g_hInst, NULL);
	hEdit = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_BORDER | WS_VSCROLL |
		ES_AUTOHSCROLL | ES_MULTILINE, 10, 10, 200, 25, win_hWnd, (HMENU)MEMO_EDIT, g_hInst, NULL);
	SendMessage(hCombo, WM_SETFONT, (WPARAM)mainFont[1], MAKELPARAM(FALSE, 0));
	SendMessage(hEdit, WM_SETFONT, (WPARAM)mainFont[1], MAKELPARAM(FALSE, 0));

	//  ʱȭ
	if (arMemoBack[0].color == 0) {
		for (sNamedColor& nc : arMemoBack) {
			nc.color = GetColorFromName(nc.name);
		}
		for (sNamedColor& nc : arMemoFore) {
			nc.color = GetColorFromName(nc.name);
		}
	}

	//       ʱȭ
	nowIdx = -1;

	// ޸  о´. 
	LoadMemoList();

	// ޺ ڽ ޸  ä ְ  ׸  ش. 
	for (size_t i = 0; i < arMemo.size(); i++) {
		SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)arMemo[i]->title);
	}

	if (nowIdx == -1) {
		SetWindowText(hEdit, L"޸ ϳ ϴ.\r\n+ ư  ޸ ߰Ͻʽÿ.");
		EnableWindow(hEdit, FALSE);
	} else {
		SendMessage(hCombo, CB_SETCURSEL, nowIdx, 0);
		SetWindowText(hEdit, arMemo[nowIdx]->content);
	}

	return 0;
}

LRESULT CMemo::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	SaveMemo(nowIdx);
	if (isModi) {
		SaveMemoList();
	}
	return 0;
}

LRESULT CMemo::OnSize(WPARAM wParam, LPARAM lParam)
{
	CWindow::OnSize(wParam, lParam);

	int w = LOWORD(lParam);
	int h = HIWORD(lParam);

	MoveWindow(hCombo, 2, 2, w - 70, 200, TRUE);
	MoveWindow(hAdd, w - 66, 5, 20, 20, TRUE);
	MoveWindow(hDelete, w - 44, 5, 20, 20, TRUE);
	MoveWindow(hView, w - 22, 5, 20, 20, TRUE);
	MoveWindow(hEdit, 2, 28, w - 4, h - 30, TRUE);

	return 0;
}

LRESULT CMemo::OnCommand(WPARAM wParam, LPARAM lParam)
{
	sMemo* pMemo;
	TCHAR name[64];
	bool find;
	int idx;
	TCHAR mes[128];

	switch (LOWORD(wParam)) {
	case MEMO_ADD:
		SaveMemo(nowIdx);

		//  ޸ ȣ ã´. 
		for (int i = 1;; i++) {
			wsprintf(name, L" ޸%d", i);
			find = false;
			for (size_t m = 0; m < arMemo.size(); m++) {
				if (lstrcmp(arMemo[m]->title, name) == 0) {
					find = true;
					break;
				}
			}
			if (find == false) break;
		}

		//  0   ʱȭѴ.  ׷   ϰ ȴ. 
		pMemo = (sMemo*)calloc(sizeof(sMemo), 1);
		lstrcpy(pMemo->title, name);
		//     ش. 
		pMemo->x = 10;
		pMemo->y = 10;
		pMemo->w = 400;
		pMemo->h = 500;
		lstrcpy(pMemo->fontFace, L" ");
		pMemo->fontSize = 16;
		pMemo->isText = true;
		pMemo->foreColor = RGB(0, 0, 0);
		pMemo->backColor = arMemoBack[arMemo.size() % Count(arMemoBack)].color;
		pMemo->wordWrap = false;
		pMemo->content = (TCHAR*)calloc(1, sizeof(TCHAR));
		pMemo->content_len = 1;
		pMemo->isModi = false;
		pMemo->pViewer = NULL;

		arMemo.push_back(pMemo);
		nowIdx = SendMessage(hCombo, CB_ADDSTRING, 0, (LPARAM)pMemo->title);
		SendMessage(hCombo, CB_SETCURSEL, nowIdx, 0);

		SetWindowText(hEdit, L"");
		EnableWindow(hEdit, TRUE);
		MySetImeMode(hEdit, TRUE);
		SetFocus(hEdit);

		isModi = true;
		break;
	case MEMO_DELETE:
		idx = SendMessage(hCombo, CB_GETCURSEL, 0, 0);
		if (idx != -1) {
			GetWindowText(hCombo, name, 64);
			wsprintf(mes, L"%s ޸ մϴ.", name);
			if (MessageBox(win_hWnd, mes, L"", MB_YESNO) == IDYES) {

				//    ݴ´. , ̶ θ  ü  ϸ  θ𿡰  û  ʿ䰡 .
				// ı ϸ  WM_USER+1 ̴µ OnUser1 ó  arMemo[idx] Ǿ  ٿȴ. 
				if (arMemo[idx]->pViewer != NULL) {
					arMemo[idx]->pViewer->destroyBySelf = false;
					DestroyWindow(arMemo[idx]->pViewer->win_hWnd);
					delete(arMemo[idx]->pViewer);
				}

				//  ϰ ޸ Ѵ.
				free(arMemo[idx]->content);
				arMemo.erase(arMemo.begin() + idx);

				// ޺ .  ׸̾ ׸ ̵
				SendMessage(hCombo, CB_DELETESTRING, idx, 0);
				if (nowIdx == SendMessage(hCombo, CB_GETCOUNT, 0, 0)) {
					nowIdx--;
				}
				//  ġ ޸ о
				if (nowIdx == -1) {
					SetWindowText(hEdit, L"޸ ϳ ϴ.\r\n+ ư  ޸ ߰Ͻʽÿ.");
					EnableWindow(hEdit, FALSE);
				} else {
					SendMessage(hCombo, CB_SETCURSEL, nowIdx, 0);
					pMemo = arMemo[nowIdx];
					SetWindowText(hEdit, pMemo->content);
				}

			}
		}
		break;
	case MEMO_VIEW:
		if (nowIdx != -1) {
			// ϴ ϴź ϰ
			SaveMemo(nowIdx);
			//    Ŀ ְ ƴϸ Ѵ.
			if (arMemo[nowIdx]->pViewer != NULL) {
				SetFocus(arMemo[nowIdx]->pViewer->win_hWnd);
				arMemo[nowIdx]->pViewer->RefreshMemo();
			} else {
				arMemo[nowIdx]->pViewer = new CMemoViewer();
				arMemo[nowIdx]->pViewer->Create(this, nowIdx);
			}
		}
		break;
	case MEMO_COMBO:
		switch (HIWORD(wParam)) {
		case CBN_SELCHANGE:
			SaveMemo(nowIdx);

			//  ޸  о´. 
			nowIdx = SendMessage(hCombo, CB_GETCURSEL, 0, 0);
			pMemo = arMemo[nowIdx];
			SetWindowText(hEdit, pMemo->content);

			break;
		}
		break;
	case MEMO_EDIT:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			if (nowIdx != -1) {
				// ޸ ü Ͽ ȭ   д. 
				arMemo[nowIdx]->isModi = true;
				isModi = true;
			}
			break;
		}
		break;
	}
	return 0;
}

//     ޽ δ. wParam ޸ idx Ѵ.
LRESULT CMemo::OnUser1(WPARAM wParam, LPARAM lParam)
{
	delete(arMemo[wParam]->pViewer);
	arMemo[wParam]->pViewer = NULL;
	return 0;
}

void CMemo::SaveMemo(int idx)
{
	sMemo* pMemo;

	//  ޸  ¿ ׳ Ѵ. 
	if (idx == -1) return;

	//  ޸ Ǿ ̿ ߾ ޸ Ҵϰ Ѵ. 
	pMemo = arMemo[idx];
	if (pMemo->isModi == true) {
		SaveMemo(pMemo, hEdit);
		pMemo->isModi = false;
		isModi = true;
	}
}

// ޸  hEdit  Ѵ. hEdit    ְ ޸   ִ. 
void CMemo::SaveMemo(sMemo* pMemo, HWND hEdit)
{
	//  Ṯںиŭ ҴѴ.
	int newlen = GetWindowTextLength(hEdit) + 1;
	if (pMemo->content_len < newlen) {
		pMemo->content = (TCHAR*)realloc(pMemo->content, newlen * sizeof(TCHAR));
		pMemo->content_len = newlen;
	}
	GetWindowText(hEdit, pMemo->content, pMemo->content_len);
}

void CMemo::SaveMemoList()
{
	TCHAR Path[MAX_PATH];
	HANDLE hFile;
	DWORD dwWritten;

	GetMemoFilePath(Path);
	hFile = CreateFile(Path, GENERIC_WRITE, 0, NULL,
		CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	// ĺ 
	LPCTSTR magic = L"SoEntyMemo";
	WriteFile(hFile, magic, lstrlen(magic) * sizeof(TCHAR), &dwWritten, NULL);
	//  
	int Ver = 100;
	WriteFile(hFile, &Ver, sizeof(Ver), &dwWritten, NULL);
	//   ޸ ȣ 
	WriteFile(hFile, &nowIdx, sizeof(nowIdx), &dwWritten, NULL);
	size_t num = arMemo.size();
	WriteFile(hFile, &num, sizeof(num), &dwWritten, NULL);

	// ȸϸ ޸ 
	for (size_t i = 0; i < arMemo.size(); i++) {
		// ޸  .
		WriteFile(hFile, arMemo[i], sizeof(sMemo), &dwWritten, NULL);
		// ޸  .   ڵ  . 
		WriteFile(hFile, arMemo[i]->content, arMemo[i]->content_len * sizeof(TCHAR), &dwWritten, NULL);
	}

	CloseHandle(hFile);
}

void CMemo::LoadMemoList()
{
	TCHAR Path[MAX_PATH];
	HANDLE hFile;
	DWORD dwRead;

	GetMemoFilePath(Path);
	hFile = CreateFile(Path, GENERIC_READ, 0, NULL,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	//      ׳ Ѵ. 
	if (hFile == INVALID_HANDLE_VALUE) {
		return;
	}
	LPCTSTR magic = L"SoEntyMemo";
	TCHAR buf[100] = { 0, };
	ReadFile(hFile, &buf, lstrlen(magic) * sizeof(TCHAR), &dwRead, NULL);
	if (lstrcmp(buf, magic) != 0) {
		return;
	}

	//  Ȯ
	int ver;
	ReadFile(hFile, &ver, sizeof(int), &dwRead, NULL);
	if (ver != 100) {
		return;
	}

	ReadFile(hFile, &nowIdx, sizeof(nowIdx), &dwRead, NULL);
	int num;
	ReadFile(hFile, &num, sizeof(num), &dwRead, NULL);

	for (int i = 0; i < num; i++) {
		sMemo* pMemo;
		pMemo = (sMemo*)malloc(sizeof(sMemo));
		ReadFile(hFile, pMemo, sizeof(sMemo), &dwRead, NULL);
		pMemo->content = (TCHAR*)calloc(pMemo->content_len, sizeof(TCHAR));
		ReadFile(hFile, pMemo->content, pMemo->content_len * sizeof(TCHAR), &dwRead, NULL);
		arMemo.push_back(pMemo);
	}

	CloseHandle(hFile);
}

//    ϸ.memo  θ Ѵ. 
void CMemo::GetMemoFilePath(TCHAR* Path)
{
	GetModuleFileName(NULL, Path, MAX_PATH);
	TCHAR* p = _tcsrchr(Path, '.');
	*(p + 1) = 0;
	lstrcat(Path, dget_id.c_str());
}

void CMemoViewer::Create(CMemo* pMemoWidget, int idx)
{
	this->pMemoWidget = pMemoWidget;
	this->nowIdx = idx;
	this->pMemo = pMemoWidget->arMemo[idx];

	//   ġ 츦 Ѵ. 
	CreateWindow(TEXT("CWindow"), pMemo->title, WS_POPUPWINDOW | WS_THICKFRAME | WS_VISIBLE,
		pMemo->x, pMemo->y, pMemo->w, pMemo->h,
		NULL, (HMENU)NULL, g_hInst, this);

	MoveWindow(win_hWnd, pMemo->x, pMemo->y, pMemo->w, pMemo->h, FALSE);
}

LRESULT CMemoViewer::OnMessage(UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	POINT pt;

	switch (iMessage)
	{
	case WM_NCHITTEST:
		int nHit;
		nHit = (int)DefWindowProc(win_hWnd, WM_NCHITTEST, wParam, lParam);
		pt.x = (int)(short)LOWORD(lParam);
		pt.y = (int)(short)HIWORD(lParam);
		ScreenToClient(win_hWnd, &pt);

		if (nHit == HTCLIENT) {
			if (pt.y < mainWindow.capThick) {
				return HTCAPTION;
			}
		}

		return nHit;
	case WM_SETFOCUS:
		RefreshMemo();
		SetFocus(hEdit);
		return 0;
	case WM_CTLCOLOREDIT:
		if ((HWND)lParam == hEdit) {
			SetTextColor((HDC)wParam, pMemo->foreColor);
			SetBkColor((HDC)wParam, pMemo->backColor);
			return (LRESULT)backBrush;
		}
		break;
	}

	return CWindow::OnMessage(iMessage, wParam, lParam);
}

LRESULT CMemoViewer::OnCreate(WPARAM wParam, LPARAM lParam)
{
	destroyBySelf = true;

	hClose = CreateWindow(TEXT("GrpBtn"), NULL, WS_CHILD | WS_VISIBLE | GBS_PUSH,
		0, 0, 16, 16, win_hWnd, (HMENU)MV_CLOSE, g_hInst, NULL);
	SendMessage(hClose, GBM_SETIMAGE, MAKEWPARAM(IDB_CLOSEUP, IDB_CLOSEHOT), MAKEWPARAM(IDB_CLOSEDOWN, IDB_CLOSEUP));
	hAttr = CreateWindow(TEXT("GrpBtn"), NULL, WS_CHILD | WS_VISIBLE | GBS_PUSH,
		0, 0, 16, 16, win_hWnd, (HMENU)MV_ATTR, g_hInst, NULL);
	SendMessage(hAttr, GBM_SETIMAGE, MAKEWPARAM(IDB_PROPUP, IDB_PROPHOT), MAKEWPARAM(IDB_PROPDOWN, IDB_PROPUP));
	hEdit = CreateWindow(TEXT("edit"), NULL, WS_CHILD | WS_VISIBLE | WS_VSCROLL | ES_MULTILINE |
		ES_AUTOHSCROLL, 0, 0, 200, 25, win_hWnd, (HMENU)MV_EDIT, g_hInst, NULL);

	fontEdit = CreateFont(pMemo->fontSize, 0, 0, 0, 0, 0, 0, 0, HANGUL_CHARSET, 3, 2, 1,
		VARIABLE_PITCH | FF_MODERN, pMemo->fontFace);
	SendMessage(hEdit, WM_SETFONT, (WPARAM)fontEdit, MAKELPARAM(FALSE, 0));
	backBrush = CreateSolidBrush(pMemo->backColor);

	SetWindowText(hEdit, pMemo->content);
	SetFocus(hEdit);
	isModi = false;

	return 0;
}

LRESULT CMemoViewer::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	//   ġ Ѵ.
	RECT wrt;
	GetWindowRect(win_hWnd, &wrt);
	pMemo->x = wrt.left;
	pMemo->y = wrt.top;
	pMemo->w = (wrt.right - wrt.left);
	pMemo->h = (wrt.bottom - wrt.top);

	DeleteObject(fontEdit);
	DeleteObject(backBrush);
	// θ𿡰 Ḧ ˷  ü 쵵 Ѵ. ı  ޽  óؾ ϱ  Send ƴϰ Post. 
	// , ڽ    θ𿡰 ı ûϰ θ  ı  ׷ ʿ . 
	if (destroyBySelf) {
		PostMessage(pMemoWidget->win_hWnd, WM_USER + 1, nowIdx, 0);
	}
	return 0;
}

void CMemoViewer::OnDraw(HDC hdc, int width, int height)
{
	// ĸ   ä
	HBRUSH brush = CreateSolidBrush(pMemo->backColor);
	FillRect(hdc, 0, 0, width, mainWindow.capThick, brush);
	DeleteObject(brush);

	// Ʒʿ ȸ ϳ ߴ´.   Ѱ ̴. 
	HPEN pen, oldPen;
	pen = CreatePen(PS_SOLID, 1, RGB(128, 128, 128));
	oldPen = (HPEN)SelectObject(hdc, pen);
	MoveToEx(hdc, 5, mainWindow.capThick - 1, NULL); LineTo(hdc, width - 5, mainWindow.capThick - 1);
	DeleteObject(SelectObject(hdc, oldPen));

	SetBkMode(hdc, TRANSPARENT);
	HFONT oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
	TextOutVCenter(hdc, 4, mainWindow.capThick / 2, pMemo->title);
	SelectObject(hdc, oldFont);

}

void CMemoViewer::SendMemoToWidget()
{
	// Ǿ ޸ Ѵ. 
	if (isModi) {
		pMemoWidget->SaveMemo(pMemo, hEdit);
		//  ϰ ִ ޸ ǥϰ  Ʈ  Ѵ. 
		if (pMemoWidget->nowIdx == nowIdx) {
			SetWindowText(pMemoWidget->hEdit, pMemo->content);
		}
		isModi = false;
	}
}

LRESULT CMemoViewer::OnSize(WPARAM wParam, LPARAM lParam)
{
	CWindow::OnSize(wParam, lParam);

	int w = LOWORD(lParam);
	int h = HIWORD(lParam);

	MoveWindow(hClose, w - 20, 4, 16, 16, TRUE);
	MoveWindow(hAttr, w - 40, 4, 16, 16, TRUE);
	MoveWindow(hEdit, 0, mainWindow.capThick, w, h - mainWindow.capThick, TRUE);

	return 0;
}

INT_PTR CALLBACK MemoDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CMemoViewer* pViewer;
	static CMemo::sMemo* pMemo;
	LPMEASUREITEMSTRUCT lpmis;
	int idx;

	switch (iMessage) {
	case WM_INITDIALOG:
		pViewer = (CMemoViewer*)lParam;
		pMemo = pViewer->pMemo;

		if (pMemo->isText) {
			CheckRadioButton(hDlg, IDC_RAFORMAT1, IDC_RAFORMAT2, IDC_RAFORMAT1);
		} else {
			CheckRadioButton(hDlg, IDC_RAFORMAT1, IDC_RAFORMAT2, IDC_RAFORMAT2);
		}

		SetDlgItemText(hDlg, IDC_EDTITLE, pMemo->title);

		SendDlgItemMessage(hDlg, IDC_LIFONT, LB_ADDSTRING, 0, (LPARAM)L"");
		SendDlgItemMessage(hDlg, IDC_LIFONT, LB_ADDSTRING, 0, (LPARAM)L"");
		SendDlgItemMessage(hDlg, IDC_LIFONT, LB_ADDSTRING, 0, (LPARAM)L"ü");
		SendDlgItemMessage(hDlg, IDC_LIFONT, LB_ADDSTRING, 0, (LPARAM)L" ");

		if (lstrcmp(pMemo->fontFace, L"") == 0) SendDlgItemMessage(hDlg, IDC_LIFONT, LB_SETCURSEL, 0, 0);
		if (lstrcmp(pMemo->fontFace, L"") == 0) SendDlgItemMessage(hDlg, IDC_LIFONT, LB_SETCURSEL, 1, 0);
		if (lstrcmp(pMemo->fontFace, L"ü") == 0) SendDlgItemMessage(hDlg, IDC_LIFONT, LB_SETCURSEL, 2, 0);
		if (lstrcmp(pMemo->fontFace, L" ") == 0) SendDlgItemMessage(hDlg, IDC_LIFONT, LB_SETCURSEL, 3, 0);

		SendDlgItemMessage(hDlg, IDC_SPINFONTSIZE, UDM_SETRANGE, 0, MAKELPARAM(64, 8));
		SetDlgItemInt(hDlg, IDC_EDFONTSIZE, pMemo->fontSize, FALSE);

		// ŭ ޺ ڽ ä   Ѵ. ǥ  ̸ 0 Ѵ.
		idx = 0;
		for (int i = 0; i < Count(arMemoBack); i++) {
			SendDlgItemMessage(hDlg, IDC_CBBACK, CB_ADDSTRING, 0, 0);
			if (pMemo->backColor == arMemoBack[i].color) idx = i;
		}
		SendDlgItemMessage(hDlg, IDC_CBBACK, CB_SETCURSEL, idx, 0);

		idx = 0;
		for (int i = 0; i < Count(arMemoFore); i++) {
			SendDlgItemMessage(hDlg, IDC_CBFORE, CB_ADDSTRING, 0, 0);
			if (pMemo->foreColor == arMemoFore[i].color) idx = i;
		}
		SendDlgItemMessage(hDlg, IDC_CBFORE, CB_SETCURSEL, idx, 0);

		return TRUE;
	case WM_MEASUREITEM:
		lpmis = (LPMEASUREITEMSTRUCT)lParam;
		lpmis->itemHeight = 18;
		return TRUE;
	case WM_DRAWITEM:
		DrawOwnerItem(lParam, wParam == IDC_CBFORE ? arMemoFore : arMemoBack);
		return TRUE;
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDOK:
			GetDlgItemText(hDlg, IDC_EDTITLE, pMemo->title, Count(pMemo->title));

			idx = SendDlgItemMessage(hDlg, IDC_LIFONT, LB_GETCURSEL, 0, 0);
			if (idx == 0) lstrcpy(pMemo->fontFace, L"");
			if (idx == 1) lstrcpy(pMemo->fontFace, L"");
			if (idx == 2) lstrcpy(pMemo->fontFace, L"ü");
			if (idx == 3) lstrcpy(pMemo->fontFace, L" ");

			pMemo->fontSize = GetDlgItemInt(hDlg, IDC_EDFONTSIZE, NULL, FALSE);
			pMemo->isModi = true;
			EndDialog(hDlg, IDOK);
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg, IDCANCEL);
			return TRUE;
		case IDC_CBFORE:
		case IDC_CBBACK:
			switch (HIWORD(wParam)) {
			case CBN_SELCHANGE:
				idx = SendDlgItemMessage(hDlg, LOWORD(wParam), CB_GETCURSEL, 0, 0);
				if (LOWORD(wParam) == IDC_CBFORE) {
					pMemo->foreColor = arMemoFore[idx].color;
				} else {
					pMemo->backColor = arMemoBack[idx].color;
				}
				break;
			}
			return TRUE;
		}
		break;
	}
	return FALSE;
}

LRESULT CMemoViewer::OnCommand(WPARAM wParam, LPARAM lParam)
{
	switch (LOWORD(wParam)) {
	case MV_CLOSE:
		DestroyWindow(win_hWnd);
		break;
	case MV_ATTR:
		if (DialogBoxParam(g_hInst, MAKEINTRESOURCE(IDD_MEMO), win_hWnd, MemoDlgProc, (LPARAM)this) == IDOK) {
			DeleteObject(fontEdit);
			fontEdit = CreateFont(pMemo->fontSize, 0, 0, 0, 0, 0, 0, 0, HANGUL_CHARSET, 3, 2, 1,
				VARIABLE_PITCH | FF_MODERN, pMemo->fontFace);
			SendMessage(hEdit, WM_SETFONT, (WPARAM)fontEdit, MAKELPARAM(FALSE, 0));
			DeleteObject(backBrush);
			backBrush = CreateSolidBrush(pMemo->backColor);

			//  ٲ   ޺ ڿ ٲٰ  ŸƲ ٵ ٲ۴. 
			TCHAR tTitle[64];
			SendMessage(pMemoWidget->hCombo, CB_GETLBTEXT, nowIdx, (LPARAM)tTitle);
			if (lstrcmp(pMemo->title, tTitle) != 0) {
				// ޺ ׸ ڿ  ٲٴ    .      
				//     ã  
				int oldIdx = SendMessage(pMemoWidget->hCombo, CB_GETCURSEL, 0, 0);
				SendMessage(pMemoWidget->hCombo, CB_DELETESTRING, nowIdx, 0);
				SendMessage(pMemoWidget->hCombo, CB_INSERTSTRING, nowIdx, (LPARAM)pMemo->title);
				SendMessage(pMemoWidget->hCombo, CB_SETCURSEL, oldIdx, 0);
				//  ŸƲ ٵ ٽ ׸. 
				InvalidateRect(win_hWnd, NULL, TRUE);
			}
		}
		break;
	case MV_EDIT:
		switch (HIWORD(wParam)) {
		case EN_CHANGE:
			isModi = true;
			break;
			// Ŀ    Ѵ.   ڵ ȴ. 
		case EN_KILLFOCUS:
			SendMemoToWidget();
			return 0;
		}
		break;
	}

	return 0;
}

void CMemoViewer::RefreshMemo()
{
	SetWindowText(hEdit, pMemo->content);
}

LRESULT CDday::OnCreate(WPARAM wParam, LPARAM lParam)
{
	LoadSetting();
	SetTimer(win_hWnd, 1, 60000, NULL);
	SendMessage(win_hWnd, WM_TIMER, 1, 0);

	return 0;
}

LRESULT CDday::OnDestroy(WPARAM wParam, LPARAM lParam)
{
	KillTimer(win_hWnd, 1);
	return 0;
}

LRESULT CDday::OnTimer(WPARAM wParam, LPARAM lParam)
{
	if (targetTitle == L"") {
		return 0;
	}

	SYSTEMTIME now;
	FILETIME nowFt, targetFt;
	INT64 now64, target64;
	int diffMin, diffHour, diffDay;

	GetLocalTime(&now);
	SystemTimeToFileTime(&now, &nowFt);
	SystemTimeToFileTime(&targetDate, &targetFt);
	now64 = (((INT64)nowFt.dwHighDateTime) << 32) + nowFt.dwLowDateTime;
	target64 = (((INT64)targetFt.dwHighDateTime) << 32) + targetFt.dwLowDateTime;
	diffMin = ABS(int((now64 - target64) / 10000000 / 60));
	diffHour = diffMin / 60 % 24;
	diffDay = diffMin / 1440;

	if (displayMinute) {
		wsprintf(remain, L"%d %dð %d", diffDay, diffHour, diffMin % 60);
	} else if (displayHour) {
		wsprintf(remain, L"%d %dð", diffDay, diffHour);
	} else {
		wsprintf(remain, L"%d", diffDay);
	}

	if (now64 > target64) {
		lstrcat(remain, L"°");
	} else {
		lstrcat(remain, L"");
	}

	//   ٲ  ٽ ׸. 
	if (lstrcmp(remain, remainOld) != 0) {
		InvalidateRect(win_hWnd, NULL, FALSE);
	}
	lstrcpy(remainOld, remain);

	return 0;
}

void CDday::OnDraw(HDC hdc, int width, int height)
{
	HFONT oldFont;
	int fontIndex;

	SetBkMode(hdc, TRANSPARENT);
	if (targetTitle == L"") {
		RECT crt = { 0, 0, width, height };
		InflateRect(&crt, -2, -5);
		SetTextColor(hdc, GetColorFromName(L"OrangeRed"));
		oldFont = (HFONT)SelectObject(hdc, mainFont[1]);
		LPCTSTR mes = L"Dday ī\r\n콺  ư  ǥ ¥  ض.";
		DrawText(hdc, mes, -1, &crt, DT_WORDBREAK);
		SelectObject(hdc, oldFont);
		return;
	}

	oldFont = (HFONT)SelectObject(hdc, mainFont[3]);
	TextOutSz(hdc, 5, 5, targetTitle.c_str());
	SelectObject(hdc, oldFont);

	if (displayMinute) {
		fontIndex = 3;
	} else if (displayHour) {
		fontIndex = 4;
	} else {
		fontIndex = 5;
	}
	if (width < 130) fontIndex--;
	if (width < 100) fontIndex--;

	oldFont = (HFONT)SelectObject(hdc, mainFont[fontIndex]);
	SetTextAlign(hdc, TA_CENTER);
	SetTextColor(hdc, GetColorFromName(L"Blue"));
	TextOutVCenter(hdc, width/2, height / 2 + 10, remain);
	SelectObject(hdc, oldFont);
}

LRESULT CDday::OnContextMenu(WPARAM wParam, LPARAM lParam)
{
	if (!IsWindow(hOptionPopup)) {
		hOptionPopup = CreateDialogParam(g_hInst, MAKEINTRESOURCE(IDD_DDAY),
			win_hWnd, DdayDlgProc, (LPARAM)this);
		ShowWindow(hOptionPopup, SW_SHOW);
	}

	return 0;
}

void CDday::LoadSetting()
{
	TCHAR buf[256];
	setting.get(dget_id, L"targetTitle", L"", buf, Count(buf));
	targetTitle = buf;
	targetDate.wYear = setting.get(dget_id, L"targetYear", 0);
	targetDate.wMonth = setting.get(dget_id, L"targetMonth", 0);
	targetDate.wDay = setting.get(dget_id, L"targetDay", 0);
	displayHour = setting.get(dget_id, L"displayHour", false);
	displayMinute = setting.get(dget_id, L"displayMinute", false);
}

void CDday::SaveSetting()
{
	setting.set(dget_id, L"targetTitle", targetTitle.c_str());
	setting.set(dget_id, L"targetYear", targetDate.wYear);
	setting.set(dget_id, L"targetMonth", targetDate.wMonth);
	setting.set(dget_id, L"targetDay", targetDate.wDay);
	setting.set(dget_id, L"displayHour", displayHour);
	setting.set(dget_id, L"displayMinute", displayMinute);
}

INT_PTR CALLBACK CDday::DdayDlgProc(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	static CDday* pWidget;

	switch (iMessage) {
	case WM_INITDIALOG:
		pWidget = (CDday*)lParam;
		RECT wrt;
		GetWindowRect(pWidget->win_hWnd, &wrt);
		MovePopupToSide(hDlg, wrt.left, wrt.top);

		if (pWidget->targetTitle == L"") {
			SYSTEMTIME st;
			GetLocalTime(&st);
			SetDlgItemInt(hDlg, IDC_EDTARGETYEAR, st.wYear, FALSE);
			SetDlgItemInt(hDlg, IDC_EDTARGETMONTH, st.wMonth, FALSE);
			SetDlgItemInt(hDlg, IDC_EDTARGETDAY, st.wDay, FALSE);
		} else {
			SetDlgItemText(hDlg, IDC_EDTARGETTITLE, pWidget->targetTitle.c_str());
			SetDlgItemInt(hDlg, IDC_EDTARGETYEAR, pWidget->targetDate.wYear, FALSE);
			SetDlgItemInt(hDlg, IDC_EDTARGETMONTH, pWidget->targetDate.wMonth, FALSE);
			SetDlgItemInt(hDlg, IDC_EDTARGETDAY, pWidget->targetDate.wDay, FALSE);
		}

		CheckDlgButton(hDlg, IDC_CHKDISPLAYHOUR, pWidget->displayHour);
		CheckDlgButton(hDlg, IDC_CHKDISPLAYMINUTE, pWidget->displayMinute);

		return TRUE;
	case WM_NCACTIVATE:
		if (wParam == FALSE && hOptionPopup != NULL) {
			TCHAR buf[256];
			GetDlgItemText(hDlg, IDC_EDTARGETTITLE, buf, Count(buf));
			pWidget->targetTitle = buf;
			pWidget->targetDate.wYear = GetDlgItemInt(hDlg, IDC_EDTARGETYEAR, NULL, FALSE);
			if (pWidget->targetDate.wYear < 100) pWidget->targetDate.wYear += 2000;
			pWidget->targetDate.wMonth = GetDlgItemInt(hDlg, IDC_EDTARGETMONTH, NULL, FALSE);
			pWidget->targetDate.wDay = GetDlgItemInt(hDlg, IDC_EDTARGETDAY, NULL, FALSE);
			pWidget->displayHour = IsDlgButtonChecked(hDlg, IDC_CHKDISPLAYHOUR);
			pWidget->displayMinute = IsDlgButtonChecked(hDlg, IDC_CHKDISPLAYMINUTE);
			// ð ǥ  е  ǥ ʴ´.
			if (pWidget->displayHour == false) {
				pWidget->displayMinute = false;
			}

			pWidget->SaveSetting();

			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			SendMessage(pWidget->win_hWnd, WM_TIMER, 1, 0);
			InvalidateRect(pWidget->win_hWnd, NULL, FALSE);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDCANCEL:
			hOptionPopup = NULL;
			DestroyWindow(hDlg);
			return TRUE;
		}
		break;
	}
	return FALSE;
}

